/*FILE------------------------------------------------------------------------*/
//
//  Comm.h
//
//  SUMMARY
//    Program common header
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#ifndef _COMM_H
#define _COMM_H

//////////////////////////////////////////////////////
//
// _uobt@
#define DOUBLE_BUFFER	2

// foCXCjVCYJEg
#define DEV_INIT		3

//////////////////////////////////////////////////////
// _CAO֘A

// C_CAO
#define SCROLL_TRACK	10	// XN[̃gbN

#define DEF_MULTIMON_AREA_X	20	// }`摜\GA_CAOW(X)
#define DEF_MULTIMON_AREA_Y	50	// }`摜\GA_CAOW(Y)

#define DEF_BKCOLOR_MONAREA	0x00D8E9EC	// 摜\GAwiF
#define DEF_FONTCOLOR_MONAREA_NORMAL	0x00FF0000	// 摜\GA\tHgJ[ijiFj
#define DEF_FONTCOLOR_MONAREA_ERROR	0x000000FF	// 摜\GA\tHgJ[ijiԐFj
#define DEF_POS_FONT_MONAREA	20	// 摜\GAtHg`ʒu

#define DEF_MAX_ZOOM_IN		0.125	// ŏk
#define DEF_MAX_ZOOM_OUT	8		// őg嗦

#define DEF_DIS_MODE_NON	0	// Av
#define DEF_DIS_MODE_SMON	1	// VOj^O[h
#define DEF_DIS_MODE_MMON	2	// }`j^O[h
#define DEF_DIS_MODE_REC	3	// R[fBO[h
#define DEF_DIS_MODE_RPLAY	4	// R[fBOt[Đ[h

#define DEF_DIS_MODE_NONGRAPH	0	//@Ot\[h
#define DEF_DIS_MODE_GRAPH		1	//@Ot\[h
// CtH[V
#define DEF_INIT_INFO_HEX	FALSE	// CtH[VHEX/DEC
#define DEF_INIT_INFO_REAL	FALSE	// CtH[VRealtime

// ݒ_CAO
#define DEF_STRING_LEN	4	// CEditRg[͉\

// ԃR[fBO 2007/01/19 V1.4.0.0
#define DEF_RCLN_BUFSIZE		(134217728)							// obt@TCY (128MB)
#define DEF_RCLN_MAXSECTION		(128)								// obt@̍ő敪
#define DEF_RCLN_MAXSIZE		(DEF_RCLN_BUFSIZE*16)				// 1t@CőoCgTCYi2GBj
#define STR_FILE_FRMFILTER		"SVI Frame Index File (*.frmt)|*frmt|SVI Frame File (*.frm)|*.frm|"		// Frmt@CtB^

// >>> 2010.06.28 V2.4.2.0 add
#define DEF_DIS_MODE_NONMTF	0	//@MTF_CAO\[h
#define DEF_DIS_MODE_MTF	1	//@MTF_CAO\[h
// <<< 2010.06.28 V2.4.2.0 add

//////////////////////////////////////////////////////
// ^C}[֘A

// ^C}[ID
#define ID_TIMER_MONITORING		100	// j^O^C}[ID
#define ID_TIMER_FRAMERATE		101	// t[[g^C}[ID
#define ID_TIMER_INFORMATION	102	// CtH[V^C}[ID
#define ID_TIMER_REC_WATCH		200	// R[fBOĎ^C}[ID
#define ID_TIMER_REC_PLAY		201	// R[fBOĐ^C}[ID
#define ID_TIMER_RECLONG		300	// RecLongp^oߎԕ\^C}[ID
#define ID_TIMER_RECLONG2		301	// RecLongp摜\^C}[ID

// ^C}[Ԋu
//#define TIMER_MONITORING_ELAPSE	20		// j^O^C}[Ԋu
#define TIMER_MONITORING_ELAPSE	1		// j^O^C}[Ԋu
#define TIMER_FRAMERATE_ELAPSE	4000	// t[[g^C}[Ԋu
#define TIMER_INFORMATION_ELAPSE	500	// CtH[V^C}[Ԋu
#define TIMER_REC_WATCH_ELAPSE	50		// R[fBO^C}[ĎԊu
#define TIMER_REC_PLAY_ELAPSE	20		// R[fBOt[ĐԊu
#define TIMER_RECLONG_ELAPSE	1000	// RecLongoߎԕ\Ԋu

//////////////////////////////////////////////////////
// j^O֘A
#define MON_FRAME_RETRY	500	// t[mۊmFgC
#define MON_FRAME_RETRY_WAIT	10	// t[mۊmFɂEFCg[ms]

#define MULTI_MONITOR	4	// }`j^[

#define FRM_HEADER_SIZE 40	// FRMwb_[TCY

#if 1	// 2010.03.11 2.2.0.0 ǔ[hǉ
#define DEF_CORR_MODE_OFF	0	// ǔ[hIt
#define DEF_CORR_MODE_ON	1	// ǔ[hI
#endif	// 2010.03.11 2.2.0.0

/*STRUCT----------------------------------------------------------------------*/
//  NAME
//   STRUCT_MONITORING_CUTOUT_SETTING
//
//  SUMMARY
//   j^O؂oݒ\
//
//  EXPLANATION
//   j^O؂oʒuyуTCY
//
//  REMARKS
//   NONE
//
/*STRUCT----------------------------------------------------------------------*/
typedef struct STRUCT_MONITORING_CUTOUT_SETTING
{
	int nCutX;	// ؂oʒu(X)

	int nCutY;	// ؂oʒu(Y)

	int nCutW;	// ؂oTCY(W)

	int nCutH;	// ؂oTCY(H)
} MONITORING_CUTOUT_SETTING, *PMONITORING_CUTOUT_SETTING;

/*STRUCT----------------------------------------------------------------------*/
//  NAME
//   STRUCT_MULTI_CUTOUT_SETTING
//
//  SUMMARY
//   }`j^O؂oݒ\
//
//  EXPLANATION
//   }`j^O؂oʒuyуTCY
//
//  REMARKS
//   NONE
//
/*STRUCT----------------------------------------------------------------------*/
typedef struct STRUCT_MULTI_CUTOUT_SETTING {

	BOOL bEnable;	// }`j^[ON/OFF

	int nCutX;	// ؂oʒu(X)

	int nCutY;	// ؂oʒu(Y)

	int nCutW;	// ؂oTCY(W)

	int nCutH;	// ؂oTCY(H)

} MULTI_CUTOUT_SETTING, *PMULTI_CUTOUT_SETTING;

// ؂oݒ
#define DEF_INIT_CUTX	0	// ؂oʒu(X)l
#define DEF_INIT_CUTY	0	// ؂oʒu(Y)l
#define DEF_INIT_CUTW	2048	// ؂oTCY(W)l
#define DEF_INIT_CUTH	1536	// ؂oTCY(H)l

// }`j^O؂oݒ
#define DEF_INIT_MULIT_ON	TRUE	// }`j^OON
#define DEF_INIT_MULTI_CUTX	140	// 1̐؂oʒu(X)
#define DEF_INIT_MULTI_CUTY	90	// 1̐؂oʒu(Y)
#define DEF_INIT_MULTI_RANGEX	554	// }`ʂ̉Ԋu
#define DEF_INIT_MULTI_RANGEY	420	// }`ʂ̏cԊu

#define DEF_MONTHREAD_WAIT_CNT	50	// j^OXbhImF
#define DEF_MONTHREAD_WAIT_SEC	100	// j^OXbhImFEFCg

//////////////////////////////////////////////////////
// R[fBO֘A
#define DEF_INIT_RECFRAME	50	// R[fBO荞݃t[l

#define REC_FRAME_RETRY	500	// t[mۊmFgC
#define REC_FRAME_RETRY_WAIT	50	// t[mۊmFɂEFCg[ms]

#define VSYNCB	0x0100	// VuLO
#define HSYNCB	0x0200	// HuLO

#define BIT_V(x) (x&VSYNCB)	// VSync
#define BIT_H(x) (x&HSYNCB)	// HSync

#define MAX_FRAMES 2048	// őt[



//////////////////////////////////////////////////////
// R[fBO֘A

// FRMt@Cwb_摜tH[}bg`
typedef enum FrmPictureType
{
	UYVY = 0,	//R[fBOAj^O摜f[^UYVYƂ݂Ȃ܂
	RGB565,		//R[fBOAj^O摜f[^RGB565Ƃ݂Ȃ܂
	RAW8,		//R[fBOAj^O摜f[^Y(RAW-8rbg)Ƃ݂Ȃ܂
	YUY2,		//R[fBOAj^O摜f[^YUY2Ƃ݂Ȃ܂
	YVYU,		//R[fBOAj^O摜f[^YVYUƂ݂Ȃ܂
	VYUY,		//R[fBOAj^O摜f[^YUY2Ƃ݂Ȃ܂
	RAW10,		//R[fBOAj^O摜f[^Y(RAW-10rbg)Ƃ݂Ȃ܂
	RAW12,		//R[fBOAj^O摜f[^Y(RAW-12rbg)Ƃ݂Ȃ܂
	UYVY16,		//R[fBOAj^O摜f[^UYVY-16bitƂ݂Ȃ܂
	VYUY16,		//R[fBOAj^O摜f[^VYUY-16bitƂ݂Ȃ܂
	YUY216,		//R[fBOAj^O摜f[^YUY2-16bitƂ݂Ȃ܂
	YVYU16,		//R[fBOAj^O摜f[^YVYU-16bitƂ݂Ȃ܂
	RGB56516,	//R[fBOAj^O摜f[^RGB565-16bitƂ݂Ȃ܂	add V2.4.0.0
};

#define DEF_INIT_PICTURETYEP	0	// R[fBO荞݃t[l

//////////////////////////////////////////////////////
// INIt@C֘A
#define DEF_INI_APP	"INI_SDK"	// SDK APP

#define DEF_INI_KEY_CUTX	"MON_CUTX"	// j^O؂oʒu(X)
#define DEF_INI_KEY_CUTY	"MON_CUTY"	// j^O؂oʒu(Y)
#define DEF_INI_KEY_CUTW	"MON_CUTW"	// j^O؂oTCY(W)
#define DEF_INI_KEY_CUTH	"MON_CUTH"	// j^O؂oTCY(H)

#define DEF_INI_KEY_MULTI_CHK	"MON_MULTI_CHK"	// }`j^OON/OFF

#define DEF_INI_KEY_MULTI_CUTX	"MON_MULTI_CUTX"	// }`j^O؂oʒu(X)
#define DEF_INI_KEY_MULTI_CUTY	"MON_MULTI_CUTY"	// }`j^O؂oʒu(Y)

#define DEF_INI_KEY_REC_FRAME	"RECFRAMES"	// R[fBOt[

#define DEF_INI_KEY_COLOR_HEX	"CLRBARHEX"	// J[o[Hex/Dec

#define DEF_INI_KEY_INFO_HEX	"INFOHEX"	// CtH[VHex/Dec
#define DEF_INI_KEY_INFO_REAL	"INFOREAL"	// CtH[VREALTIME ON/OFF

#define DEF_INI_KEY_INFO_PICTYPE "PICTURETYPE"	// sN`^Cv
#define DEF_INI_KEY_INFO_PICTYPE_1 "PICTURETYPE_1"	// sN`^Cv
#define DEF_INI_KEY_INFO_PICTYPE_2 "PICTURETYPE_2"	// sN`^Cv
#define DEF_INI_KEY_INFO_PICTYPE_3 "PICTURETYPE_3"	// sN`^Cv
#define DEF_INI_KEY_INFO_PICTYPE_4 "PICTURETYPE_4"	// sN`^Cv

#define	DEF_INI_KEY_INFO_VSNEG_1 "VSNEG_1" // Input VSync Invert
#define	DEF_INI_KEY_INFO_VSNEG_2 "VSNEG_2" // Input VSync Invert
#define	DEF_INI_KEY_INFO_VSNEG_3 "VSNEG_3" // Input VSync Invert
#define	DEF_INI_KEY_INFO_VSNEG_4 "VSNEG_4" // Input VSync Invert
#define DEF_INIT_VSNEG 0 // 0:Not Invert 1:Invert

#define DEF_INI_KEY_INFO_MABIKI	"MABIKI"	// t[Ԉ
#define DEF_INIT_MABIKI			0

#define DEF_INI_KEY_INFO_MABIKICNT	"MABIKICNT"	// t[Ԉ
#define DEF_INIT_MABIKICNT		0

#define DEF_INI_KEY_FRAMENODISP	"FRAMENODISP"	// t[ԍ摜\
#define DEF_INIT_FRAMENODISP	0

#define DEF_INI_KEY_INFO_SYNC	"SYNC"		// X^[g
#define DEF_INIT_SYNC			0

// >>> V1.3.0.0 add
#define DEF_INI_KEY_MONMODE "MONMODE"	// j^O[h Double/Ring
#define DEF_INI_KEY_MONTIMEOUT "MONTIMEOUT"	// j^O^CAEg 0-xxxx
// <<< V1.3.0.0 add

#define DEF_INI_KEY_MULTITRANS_FILEPATH1 "MULTITRANS_FILEPATH1"	// Jݒt@Cݒ_CAÕt@CpX1
#define DEF_INI_KEY_MULTITRANS_FILEPATH2 "MULTITRANS_FILEPATH2"	// Jݒt@Cݒ_CAÕt@CpX2
#define DEF_INI_KEY_MULTITRANS_FILEPATH3 "MULTITRANS_FILEPATH3"	// Jݒt@Cݒ_CAÕt@CpX3
#define DEF_INI_KEY_MULTITRANS_FILEPATH4 "MULTITRANS_FILEPATH4"	// Jݒt@Cݒ_CAÕt@CpX4

#define DEF_INI_KEY_REC_FILEPATH	"REC_FILEPATH"	// Ԙ^pt@C
#define DEF_INIT_REC_FILEPATH		"default"		// Ԙ^pt@Cl

// >>> V2.0.0.0 add 2009.02.02
#define DEF_INI_KEY_USERBTN_6	"BUTTON6"	// [U[{^6̖̃L[
#define DEF_INIT_USERBTN_6		"Button6"	// [U[{^6̏
#define DEF_INI_KEY_USERBTN_7	"BUTTON7"	// [U[{^7̖̃L[
#define DEF_INIT_USERBTN_7		"Button7"	// [U[{^7̏
#define DEF_INI_KEY_USERBTN_8	"BUTTON8"	// [U[{^8̖̃L[
#define DEF_INIT_USERBTN_8		"Button8"	// [U[{^8̏
#define DEF_INI_KEY_USERBTN_9	"BUTTON9"	// [U[{^9̖̃L[
#define DEF_INIT_USERBTN_9		"Button9"	// [U[{^9̏
#define DEF_INI_KEY_BOARDNO		"BOARDNO"	// SVI-03{[hԍ̖̃L[
#define DEF_INIT_BOARDNO		0			// SVI-03{[hԍ̏l
// <<< V2.0.0.0 add 2009.02.02

// >>> V2.1.0.0 add 2009.02.09
#define DEF_INI_KEY_LENSSTEP	"LENSSTEP"	// YVF[fBO␳XebṽL[
#define DEF_INIT_LENSSTEP		20			// YVF[fBO␳Xebv̏l
#define DEF_INI_KEY_LENSTH		"LENSTH"	// YVF[fBO␳l̃L[
#define DEF_INIT_LENSTH			230			// YVF[fBO␳l̏l
// <<< V2.1.0.0 add 2009.02.09

// >>> V2.1.1.0 add 2009.11.25
#define DEF_INI_KEY_BINTH		"BINTH"		// 2l\l̃L[
#define DEF_INIT_BINTH			180			// 2l\l̏l
// <<< V2.1.1.0 add 2009.11.25

#if 1	// 2010.03.11 2.2.0.0 ǔ[hǉ
#define DEF_INI_KEY_REGX		"REGX"		// ǔ@\ o^W X
#define DEF_INI_KEY_REGY		"REGY"		// ǔ@\ o^W Y
#define DEF_INI_KEY_REGW		"REGW"		// ǔ@\ o^W W
#define DEF_INI_KEY_REGH		"REGH"		// ǔ@\ o^W H

#define DEF_INIT_REGX			0			// ǔ@\ o^W X l
#define DEF_INIT_REGY			0			// ǔ@\ o^W Y l
#define DEF_INIT_REGW			100			// ǔ@\ o^W W l
#define DEF_INIT_REGH			100			// ǔ@\ o^W H l

#define DEF_INI_KEY_ROUX		"ROUX"		// ǔ@\ eT[` X
#define DEF_INI_KEY_ROUY		"ROUY"		// ǔ@\ eT[` Y

#define DEF_INIT_ROUX			4			// ǔ@\ eT[` X l
#define DEF_INIT_ROUY			4			// ǔ@\ eT[` Y l

#define DEF_INI_KEY_THRESH		"THRESH"	// ǔ@\ 臒l

#define DEF_INIT_THRESH			900000		// ǔ@\ 臒l l
#endif	// 2010.03.11 2.2.0.0

// >>> V2.4.0.0 add 2010.06.11
#define DEF_INI_KEY_RAWDPE		"RAWDPE"	// RAW-DPEtÕL[
#define DEF_INIT_RAWDPE			0			// 0:O[\A1:DPERGB\
// <<< V2.4.0.0 add 2010.06.11

// >>> V2.4.1.0 add 2010.06.18
#define DEF_INI_KEY_RAWDPEPHASE		"RAWDPEPHASE"	// RAWf[^ʑ̃L[
#define DEF_INIT_RAWDPEPHASE		0				// 0:RGGB,1:GRBG,2:GBRG,3:BGGR
// <<< V2.4.1.0 add 2010.06.18

///////////////////////////////////////////////////
// Ot쐬֘A
#define DEF_GRP_WIDTH_SIZE		256	// Ot\̈扡
#define DEF_GRP_HEIGHT_SIZE		256	// Ot\̈c
#define DEF_GRP_WIDTH_SPACE		5	// C[WԂ̗]̉
#define DEF_GRP_HEIGHT_SPACE	5	// C[WԂ̗]̏c

//////////////////////////////////////////////////////
// YUV,RGBϊ֘A
#define YUV_OFFSET 100000	// YUV->RGBϊ̏_ItZbg

#define DEF_COLORBAR_HEX	FALSE	// J[o[\

//////////////////////////////////////////////////////
// Jp[ON/OFF
#define DEF_CAM_PW_ON	0x00000004		// Jp[rbgON
#define DEF_CAM_PW_OFF	~DEF_CAM_PW_ON	// Jp[rbgOFF

#define DEF_SLV_ID		0x08	// Slave ID

#define DEF_ADR_CAMPW	0x20	// Sub address

//////////////////////////////////////////////////////
// j^O[h֘A
#define DEF_MONMODE_D		0	// _uobt@
#define DEF_MONMODE_R		1	// Oobt@
#define DEF_INIT_MONMODE	1	// _uobt@
#define DEF_INIT_MONTIMEOUT	0	// j^O^CAEg(0:)

#define DEF_MON_NONE		0	// 
#define DEF_MON_OPEN		1	// Openς
#define DEF_MON_START		2	// Startς

#if	1 // 2012.02.08 3.0.1.0 1/2ԈON/OFF
#define DEF_ADR_MABIKI_1	0x38	// Sub address
#define DEF_ADR_MABIKI_2	0x39	// Sub address
#endif // 2012.02.08 3.0.1.0 1/2ԈON/OFF

#if 1 // 2010.06.28 V2.4.2.0 MTFǉ
//////////////////////////////////////////////////////
// MTF֘A
#define	DEF_INI_KEY_MTF_W_X		"MTF_W_X"	// White-x key
#define	DEF_INI_KEY_MTF_W_Y		"MTF_W_Y"	// White-y key
#define	DEF_INI_KEY_MTF_W_W		"MTF_W_W"	// White-width key
#define	DEF_INI_KEY_MTF_W_H		"MTF_W_H"	// White-height key
#define	DEF_INI_KEY_MTF_B_X		"MTF_B_X"	// Black-x key
#define	DEF_INI_KEY_MTF_B_Y		"MTF_B_Y"	// Black-y key
#define	DEF_INI_KEY_MTF_B_W		"MTF_B_W"	// Black-width key
#define	DEF_INI_KEY_MTF_B_H		"MTF_B_H"	// Black-height key
#define	DEF_INI_KEY_MTF_1_X		"MTF_1_X"	// 1Area-x key
#define	DEF_INI_KEY_MTF_1_Y		"MTF_1_Y"	// 1Area-y key
#define	DEF_INI_KEY_MTF_1_W		"MTF_1_W"	// 1Area-width key
#define	DEF_INI_KEY_MTF_1_H		"MTF_1_H"	// 1Area-height key
#define	DEF_INI_KEY_MTF_2_X		"MTF_2_X"	// 2Area-x key
#define	DEF_INI_KEY_MTF_2_Y		"MTF_2_Y"	// 2Area-y key
#define	DEF_INI_KEY_MTF_2_W		"MTF_2_W"	// 2Area-width key
#define	DEF_INI_KEY_MTF_2_H		"MTF_2_H"	// 2Area-height key
#define	DEF_INI_KEY_MTF_3_X		"MTF_3_X"	// 3Area-x key
#define	DEF_INI_KEY_MTF_3_Y		"MTF_3_Y"	// 3Area-y key
#define	DEF_INI_KEY_MTF_3_W		"MTF_3_W"	// 3Area-width key
#define	DEF_INI_KEY_MTF_3_H		"MTF_3_H"	// 3Area-height key
#define	DEF_INI_KEY_MTF_4_X		"MTF_4_X"	// 4Area-x key
#define	DEF_INI_KEY_MTF_4_Y		"MTF_4_Y"	// 4Area-y key
#define	DEF_INI_KEY_MTF_4_W		"MTF_4_W"	// 4Area-width key
#define	DEF_INI_KEY_MTF_4_H		"MTF_4_H"	// 4Area-height key
#define	DEF_INI_KEY_MTF_5_X		"MTF_5_X"	// 5Area-x key
#define	DEF_INI_KEY_MTF_5_Y		"MTF_5_Y"	// 5Area-y key
#define	DEF_INI_KEY_MTF_5_W		"MTF_5_W"	// 5Area-width key
#define	DEF_INI_KEY_MTF_5_H		"MTF_5_H"	// 5Area-height key
#define	DEF_INI_KEY_MTF_1_CHK	"MTF_1_CHK"	// 1Area-check-on/off key
#define	DEF_INI_KEY_MTF_2_CHK	"MTF_2_CHK"	// 2Area-check-on/off key
#define	DEF_INI_KEY_MTF_3_CHK	"MTF_3_CHK"	// 3Area-check-on/off key
#define	DEF_INI_KEY_MTF_4_CHK	"MTF_4_CHK"	// 4Area-check-on/off key
#define	DEF_INI_KEY_MTF_5_CHK	"MTF_5_CHK"	// 5Area-check-on/off key
#define	DEF_INI_KEY_MTF_THRES	"MTF_THRES"	// Threshold key
#define	DEF_INI_KEY_MTF_FOLDER	"MTF_FOLDER"// Save folder key
#define	DEF_INI_KEY_MTF_NUM_FRMS	"MTF_NUM_FRMS"	// Number of frames
#endif // 2010.06.28 V2.4.2.0 MTFǉ

//////////////////////////////////////////////////////
// ʊ֐
int	CheckHex(
			int* pHex,				// [OUT] converted value
			CString strCheckData );	// [IN]  string

BOOL GetYUVOffset(int pictureType, int* y0, int* y1, int* u, int* v); // YUV|C^ItZbg擾



/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetBitmapFileHeader
//
//  PARAMETER
//    ImageSize:rbg}bvf[^TCY
//
//  SUMMARY
//    rbg}bvt@Cwb_쐬(BITMAPFILEHEADER쐬)
//
//  EXPLANATION
//    rbg}bvt@Cwb_쐬
//
//  RETURN
//	  rbg}bvt@Cwb_
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
inline BITMAPFILEHEADER	GetBitmapFileHeader( DWORD ImageSize )
{
	BITMAPFILEHEADER	BitmapFileHeader;

	BitmapFileHeader.bfType				= 0x4d42;
	BitmapFileHeader.bfSize				= ImageSize + sizeof( BITMAPFILEHEADER ) + sizeof( BITMAPINFO );;
	BitmapFileHeader.bfReserved1		= 0;
	BitmapFileHeader.bfReserved2		= 0;
	BitmapFileHeader.bfOffBits			= sizeof( BITMAPFILEHEADER ) + sizeof( BITMAPINFO );

	return BitmapFileHeader;
}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetBitmapInfo
//
//  PARAMETER
//    dwXSize rbg}bv̕
//	  dwYSize rbg}bv̍
//  SUMMARY
//    rbg}bvwb_쐬iBITMAPINFO쐬j
//
//  EXPLANATION
//    rbg}bvwb_쐬
//
//  RETURN
//	  rbg}bvwb_
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
inline	BITMAPINFO	GetBitmapInfo( DWORD dwXSize, DWORD dwYSize )
{
	BITMAPINFO BitmapInfo;

	BitmapInfo.bmiHeader.biSize				= sizeof( BITMAPINFOHEADER );
	BitmapInfo.bmiHeader.biWidth			= dwXSize;
	BitmapInfo.bmiHeader.biHeight			= dwYSize;
	BitmapInfo.bmiHeader.biPlanes			= 1;
	BitmapInfo.bmiHeader.biBitCount			= 24;
	BitmapInfo.bmiHeader.biCompression		= BI_RGB;
	BitmapInfo.bmiHeader.biSizeImage		= dwXSize * dwYSize * 3;
	BitmapInfo.bmiHeader.biXPelsPerMeter	= 1;
	BitmapInfo.bmiHeader.biYPelsPerMeter	= 1;
	BitmapInfo.bmiHeader.biClrUsed			= 0;
	BitmapInfo.bmiHeader.biClrImportant		= 0;

	return BitmapInfo;
}

/*STRUCT----------------------------------------------------------------------*/
//  NAME
//   STRUCT_FRM_HEADER
//
//  SUMMARY
//   FRMt@C-t[wb_[\
//
//  EXPLANATION
//   FRMt@C-t[wb_[
//
//  REMARKS
//   NONE
//
/*STRUCT----------------------------------------------------------------------*/
#pragma pack(1)
typedef struct STRUCT_FRM_HEADER {

	ULONG	ulWidth;		// 摜
	ULONG	ulHeight;		// 摜
	USHORT	usBitCount;		// K(8,10,12)
	short	usRsv1;			// \
	int		uiRsv1;			// \
	ULONG	ulFrameNo;		// t[ԍ(0)
	ULONG	ulFrameSize;	// t[f[^TCY(ofBO܂܂Ȃ)
	ULONG	ulPicType;		// sN`^Cv
	char	cTimeStamp[4];	// ^CX^v(gp)
	int		uiRsv2;			// \
	int		uiRsv3;			// \

} FRM_HEADER, *PFRM_HEADER;
#pragma pack()

#endif // _COMM_H End