/*FILE------------------------------------------------------------------------*/
//
//  SVIcmdsetDlg.h
//
//  SUMMARY
//    Monitoring & Recording Setting
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#if !defined(AFX_SVICMDSETDLG_H__0E19328C_B4A7_40B1_9757_6D9777355120__INCLUDED_)
#define AFX_SVICMDSETDLG_H__0E19328C_B4A7_40B1_9757_6D9777355120__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SVIcmdsetDlg.h : wb_[ t@C
//

#include "Comm.h"

/////////////////////////////////////////////////////////////////////////////
// CSVIcmdsetDlg _CAO

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CSVIcmdsetDlg
//
//  SUMMARY
//    ؂o & R[fBOݒ 
//
//  EXPLANATION
//    ؂oyуR[fBO荞݃t[̐ݒ
//    
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CSVIcmdsetDlg : public CDialog
{
// RXgNV
public:
	CSVIcmdsetDlg(CWnd* pParent = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CSVIcmdsetDlg)
	enum { IDD = IDD_CMDSET };
		// : ClassWizard ͂̈ʒuɃf[^ oǉ܂B
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSVIcmdsetDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CSVIcmdsetDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	int GetMonitoringTimeout();
	void SetMonitoringMode(int nMonitoringMode, int nMonitoringTimeout);
	int GetMonitoringMode();
	void SetMonCut(MONITORING_CUTOUT_SETTING MonCutSet);	// j^O؂o̐ݒ

	MONITORING_CUTOUT_SETTING GetMonCut();	// j^O؂o̎擾

	void SetPicType(int nPicType_1,int nPicType_2,int nPicType_3,int nPicType_4);	// PictureTypeݒ
	void GetPicType(int *nPicType_1,int *nPicType_2,int *nPicType_3,int *nPicType_4);	// PictureType擾
	// Input VSync Invertݒ
	void SetInputVSyncInvert(int nVSNeg_1,int nVSNeg_2,int nVSNeg_3,int nVSNeg_4);
	void GetInputVSyncInvert(int *nVSNeg_1,int *nVSNeg_2,int *nVSNeg_3,int *nVSNeg_4);

private:
	int m_MonMode;
	int m_MonTimeout;
	void SetMonitoringModeSetting();
	BOOL GetMonitoringModeSetting();

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetEditCtrl
//
//  PARAMETER
//    UINT nID : CEditRg[ID
//    int nLimit : ͉\
//    int nValue : ݒl
//
//  SUMMARY
//    CEditlݒ
//
//  EXPLANATION
//    CEditRg[֕͂̍ő吔Əlݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
	inline void SetEditCtrl(UINT nID, int nLimit, int nValue)	// CEditlݒ
	{
		CString csValue;
		csValue.Format("%d", nValue);
		((CEdit*)GetDlgItem(nID))->SetLimitText(nLimit);
		((CEdit*)GetDlgItem(nID))->SetWindowText(csValue);
	};

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetEditCtrl
//
//  PARAMETER
//    UINT nID : CEditRg[ID
//    int* pnValue : 擾li[^|C^
//    BOOL bChk : `FbNtO
//
//  SUMMARY
//    CEditݒl擾
//
//  EXPLANATION
//    CEditRg[ɐݒ肳Ăl𐮐lŎ擾
//
//  RETURN
//    ʌ
//
//  REMARKS
//    擾̏ꍇ̓G[Ƃ`FbN܂B
//
/*MFUNC-----------------------------------------------------------------------*/
inline BOOL GetEditCtrl(UINT nID, int* pnValue, BOOL bChk = FALSE)	// CEditl擾
	{
		CString csValue;
		((CEdit*)GetDlgItem(nID))->GetWindowText(csValue);
		*pnValue = atoi(csValue);
		if(*pnValue < 0) {
			GotoDlgCtrl(GetDlgItem(nID));
			return FALSE;
		}
		if(bChk) {
			if(*pnValue % 2) {
				GotoDlgCtrl(GetDlgItem(nID));
				return FALSE;
			}
		}
		return TRUE;
	};

	MONITORING_CUTOUT_SETTING	m_MonCutSet;	// j^O؂oݒ

	void SetPictureTypeSetting();	// PictureTypeʃRg[֐ݒ
	
	BOOL GetPictureTypeSetting();	// PictureTypeʃRg[擾
	
	BOOL WriteCaptureMode();	// SVI{[hWX^ɃLv`[[hݒ

	int m_PicType_1;		// Board_1 PictureType
	int m_PicType_2;		// Board_2 PictureType
	int m_PicType_3;		// Board_3 PictureType
	int m_PicType_4;		// Board_4 PictureType
	int m_VSNeg_1;			// Board_1 Input VSync Invert
	int m_VSNeg_2;			// Board_1 Input VSync Invert
	int m_VSNeg_3;			// Board_1 Input VSync Invert
	int m_VSNeg_4;			// Board_1 Input VSync Invert
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SVICMDSETDLG_H__0E19328C_B4A7_40B1_9757_6D9777355120__INCLUDED_)
