/*FILE------------------------------------------------------------------------*/
//
//  SVIsamDlg.cpp
//
//  SUMMARY
//    SVI SDK Main Dialog
//
//  WRITER
//    Net Vision
//
//  HISTORY
//    2013/10/xx New creation
//
/*FILE------------------------------------------------------------------------*/

#include "stdafx.h"
#include "SVIsam.h"
#include "SVIsamDlg.h"
#include "SVIcbDlg.h"
#include "SVIcmdsetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CAboutDlg
//
//  SUMMARY
//    About dialog class.
//
//  EXPLANATION
//    About dialog class.
//
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CAboutDlg
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIsamDlg _CAO

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CSVIsamDlg
//
//  PARAMETER
//    CWnd* pParent eEBhE
//
//  SUMMARY
//    RXgN^
//
//  EXPLANATION
//    NXRXgN^
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CSVIsamDlg::CSVIsamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVIsamDlg::IDD, pParent)
	, m_selid(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// YUV->RGBvZɗpW߂
	int* p;
	int n;
	for (p = m_X140200, n = 0; n <= 256; ++n)	*p++ =  140200 * (n - 128);
	for (p = m_X034414, n = 0; n <= 256; ++n)	*p++ = -34414 * (n - 128);
	for (p = m_X071414, n = 0; n <= 256; ++n)	*p++ = -71414 * (n - 128);
	for (p = m_X177200, n = 0; n <= 256; ++n)	*p++ =  177200 * (n - 128);

	// YVF[fBO␳stO
	m_bLensShadingFlag = FALSE;

	// 2l\stO
	m_bBinarizationFlag = FALSE;
}

void CSVIsamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSVIsamDlg, CDialog)
	//{{AFX_MSG_MAP(CSVIsamDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_CB, OnCb)
	ON_BN_CLICKED(IDC_MS1, OnMs1)
	ON_BN_CLICKED(IDC_OP4, OnOp4) // Cam Power ON/OFF
	ON_BN_CLICKED(IDC_OP, OnBMPSave)
	ON_BN_CLICKED(IDC_OP3, OnCmdSetting)
	ON_BN_CLICKED(IDC_BUTTON1, OnParaOpen)
	ON_BN_CLICKED(IDC_INFOUP, OnInfoup)
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonSend)
	ON_BN_CLICKED(IDC_BUTTON3, OnButtonRead)
	ON_BN_CLICKED(IDC_BUTTON4, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON5, &CSVIsamDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CSVIsamDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_SET_1, &CSVIsamDlg::OnBnClickedSet1)
	ON_BN_CLICKED(IDC_SET_2, &CSVIsamDlg::OnBnClickedSet2)
	ON_BN_CLICKED(IDC_SET_3, &CSVIsamDlg::OnBnClickedSet3)
	ON_BN_CLICKED(IDC_SET_4, &CSVIsamDlg::OnBnClickedSet4)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIsamDlg bZ[W nh

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnInitDialog
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    _CAO{bNX\
//
//  EXPLANATION
//    _CAO{bNX\ۂɏs߂ɌĂяo܂
//
//  RETURN
//    ̓tH[JXݒ
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	////////////////////////////////////////////////////////////
	// j^OɕKvȕϐ̏
	m_pMonitoringThread1 = NULL;
	m_pMonitoringThread2 = NULL;
	m_pMonitoringThread3 = NULL;
	m_pMonitoringThread4 = NULL;
	m_bMonStop = FALSE;
	m_bMonErr = FALSE;
	////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////
	// IɔhNX쐬

	// VOj^Op摜\GA
	m_SingleMonitor.AutoLoad(IDC_SINGLEMONITOR, this);

	// }`j^Op摜\GA
	m_MultiMonitor[0].AutoLoad(IDC_MULTI_MON_1, this);
	m_MultiMonitor[1].AutoLoad(IDC_MULTI_MON_2, this);
	m_MultiMonitor[2].AutoLoad(IDC_MULTI_MON_3, this);
	m_MultiMonitor[3].AutoLoad(IDC_MULTI_MON_4, this);
	
	// 摜\GA\/\ݒ肷
	ShowMon(TRUE);
	////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////
	// INIt@Cǂݍ

	// ؂oݒ̓ǂݍ
	ReadIniCutout();

	// PictureTyep擾
	ReadIniPicType();

	// j^O[h擾
	ReadIniMonMode();

	// Jݒ擾
	ReadIniMultipleTransfer();

	////////////////////////////////////////////////////////////
	// ̑
	m_pSVIcbDlg = NULL;

	// EBhE^Cgݒ
	CString csDlgTitle;
	this->GetWindowText(csDlgTitle);
	csDlgTitle += GetProductVersion();
	this->SetWindowText(csDlgTitle);

	ReadIniLensShading();		// YVF[fBOp[^̎擾
	ReadIniBinarization();		// 2l\p[^̎擾

#if 0
	// Jp[ԃ`FbN
	CString csLabel;
	if(CamPower(TRUE)) {
		// p[ON
		csLabel.LoadString(IDS_CAM_PWOFF);
	}
	else {
		// p[OFF
		csLabel.LoadString(IDS_CAM_PWON);
	}
	// {^xύX
	((CButton*)GetDlgItem(IDC_OP4))->SetWindowText(csLabel);
#endif

	// [hݒ
	SetNon();

	// {^̕ύX
	ReadIniSetButtonName();

	// j^OԃtOݒ
	m_MonState = DEF_MON_NONE; // 

	// ڑ{[h̕\
	bool bFlg = false;
	if(gggSviControl1.isExist() == true){
		((CButton*)GetDlgItem(IDC_BSEL_1))->SetCheck(TRUE);
		bFlg = true;
	}else{
		((CButton*)GetDlgItem(IDC_SET_1))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_BSEL_1))->EnableWindow(FALSE);
	}

	if(gggSviControl2.isExist() == true){
		if(bFlg == false){
			((CButton*)GetDlgItem(IDC_BSEL_2))->SetCheck(TRUE);
			bFlg = true;
		}
	}else{
		((CButton*)GetDlgItem(IDC_SET_2))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_BSEL_2))->EnableWindow(FALSE);
	}

	if(gggSviControl3.isExist() == true){
		if(bFlg == false){
			((CButton*)GetDlgItem(IDC_BSEL_3))->SetCheck(TRUE);
			bFlg = true;
		}
	}else{
		((CButton*)GetDlgItem(IDC_SET_3))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_BSEL_3))->EnableWindow(FALSE);
	}

	if(gggSviControl4.isExist() == true){
		if(bFlg == false){
			((CButton*)GetDlgItem(IDC_BSEL_4))->SetCheck(TRUE);
			bFlg = true;
		}
	}else{
		((CButton*)GetDlgItem(IDC_SET_4))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_BSEL_4))->EnableWindow(FALSE);
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnSysCommand
//
//  PARAMETER
//    nID
//    lParam
//
//  SUMMARY
//    Rg[j[
//
//  EXPLANATION
//    Rg[j[R}hI񂾂ƂƁAő\܂͍ŏ\
//    I񂾍ۂɌĂяo܂
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnPaint
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ʕ`揈
//
//  EXPLANATION
//    AvP[VEBhËꕔ̍ĕ`vƂɌĂяo܂
//
//  RETURN
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnQueryDragIcon
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ŏEBhEhbȌ
//
//  EXPLANATION
//     VXéA[U[ŏEBhEhbOĂԁA
//     J[\\邽߂ɂĂяo܂B
//
//  RETURN
//    J[\ʒu
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
HCURSOR CSVIsamDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnCb
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [Colorbar]{^
//
//  EXPLANATION
//    J[o[̕\s
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnCb()
{
	// J[o[Ԃ𒲂ׂ܂
	if(!m_pSVIcbDlg) {
		// J[o[\ĂȂꍇ
		// [hX_CAO𐶐
		m_pSVIcbDlg	= new CSVIcbDlg(AfxGetApp()->GetMainWnd());
		m_pSVIcbDlg->Create();
	}
	else {
		// J[o[ɕ\Ăꍇ
		// tH[JXJ[o[EBhE֐ݒ肷
		m_pSVIcbDlg->SetForegroundWindow();

		// J[o[ꂽƂ{^͖߂̂
		// ł͑IԂp܂
		((CButton*)GetDlgItem(IDC_CB))->SetCheck(TRUE);
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnMs1
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [SingleMonitor]{^
//
//  EXPLANATION
//    VOj^O̊JnE~gOōsB
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnMs1()
{
	// VOj^O̊Jn/~
	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;

	if(!IsSMon() || !m_pMonitoringThread1) {
		// {^̕\ԕύX
		((CButton*)GetDlgItem(IDC_MS1))->SetCheck(TRUE);
		((CButton*)GetDlgItem(IDC_OP3))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_OP4))->EnableWindow(FALSE);
		if(gggSviControl1.isExist()) ((CEdit*)GetDlgItem(IDC_BNO_1))->SetWindowText("01");
		if(gggSviControl2.isExist()) ((CEdit*)GetDlgItem(IDC_BNO_2))->SetWindowText("02");
		if(gggSviControl3.isExist()) ((CEdit*)GetDlgItem(IDC_BNO_3))->SetWindowText("03");
		if(gggSviControl4.isExist()) ((CEdit*)GetDlgItem(IDC_BNO_4))->SetWindowText("04");

		// j^O̒~
		MonStop();

		if(!IsSMon()) {
			// 摜\GA؂ւ
			ShowMon(TRUE);
		}

		// j^OJn
		if(!MonStart()) {
			((CButton*)GetDlgItem(IDC_MS1))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_OP3))->EnableWindow(TRUE);
			((CButton*)GetDlgItem(IDC_OP4))->EnableWindow(TRUE);
			return;
		}
	}
	else {
		// j^O̒~
		MonStop();
		Sleep(500);
		((CButton*)GetDlgItem(IDC_MS1))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_OP3))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_OP4))->EnableWindow(TRUE);
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBMPSave
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [BitmapSave...]{^
//
//  EXPLANATION
//    摜\GAɕ\Ă摜rbg}bvۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBMPSave()
{
	// rbg}bvۑ

	if(m_pMonitoringThread1) {
		// j^Ȍꍇ̓^C}[ꎞ~
		KillTimer(ID_TIMER_MONITORING);
		KillTimer(ID_TIMER_FRAMERATE);
	}

	CFileDialog cfd(					// t@Cۑ_CAO
		// ۑ_CAO(FALSE)
		FALSE,
		// ftHg̊gq
		// ۑɎw肷ƁAt@C̍ŌɊgqt܂B
		"bmp",
		// ftHg̃t@C
		// ݒ肵t@Cݒ肳܂
		// NULLw肷Ɖ\܂
		"default",
		// _CAOptO
		OFN_FILEMUSTEXIST|
		OFN_HIDEREADONLY|
		OFN_OVERWRITEPROMPT|
		OFN_NOCHANGEDIR|
		OFN_LONGNAMES,
		// t@CgqtB^  `[x|gq]
		"BMPt@C (*.bmp)|*.bmp|SẴt@C (*.*)|*.*|",
		// eEBhE
		NULL
	);

	if(cfd.DoModal() == IDOK) {
		// rbg}bv̕ۑ
		BitmapSave(cfd.GetPathName(), &m_RGBFrame);
	}

	if(m_pMonitoringThread1) {
		// ~^C}[̍ĊJ
		SetTimer(ID_TIMER_MONITORING, TIMER_MONITORING_ELAPSE, NULL);
		SetTimer(ID_TIMER_FRAMERATE, TIMER_FRAMERATE_ELAPSE, NULL);
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnCmdSetting
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [Setting...]{^
//
//  EXPLANATION
//    ݒ_CAO\Aj^O̐؂oʒu̐ݒs
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnCmdSetting()
{
	CSVIcmdsetDlg dlg;

	// ݂̃j^O؂oݒ
	dlg.SetMonCut(m_MonCutSet);

	// Picture Typeݒ
	dlg.SetPicType(m_PicType_1,m_PicType_2,m_PicType_3,m_PicType_4);

	// Input VSync Invertݒ
	dlg.SetInputVSyncInvert(m_VSNeg_1,m_VSNeg_2,m_VSNeg_3,m_VSNeg_4);

	// j^O[hݒ
	dlg.SetMonitoringMode(m_MonMode, m_MonTimeout);

	// Settin_CAO\
	if(dlg.DoModal() == IDOK) {
		// eݒlf

		// j^O؂o擾
		m_MonCutSet = dlg.GetMonCut();

		// Picture Type擾
		dlg.GetPicType(&m_PicType_1,&m_PicType_2,&m_PicType_3,&m_PicType_4);

		// Input VSync Invert擾
		dlg.GetInputVSyncInvert(&m_VSNeg_1,&m_VSNeg_2,&m_VSNeg_3,&m_VSNeg_4);

		// j^O[h擾
		m_MonMode = dlg.GetMonitoringMode();
		m_MonTimeout = dlg.GetMonitoringTimeout();
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnParaOpen
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [...]{^
//
//  EXPLANATION
//    JW[pp[^t@C̃I[vs
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnParaOpen()
{
	// JW[pp[^t@Cu*.datṽI[vs

	CFileDialog cfd(					// t@Cۑ_CAO
		// I[v_CAO(TRUE)
		TRUE,
		// ftHg̊gq
		// ۑɎw肷ƁAt@C̍ŌɊgqt܂B
		NULL,
		// ftHg̃t@C
		// ݒ肵t@Cݒ肳܂
		// NULLw肷Ɖ\܂
		"default",
		// _CAOptO
		OFN_FILEMUSTEXIST|
		OFN_HIDEREADONLY|
		OFN_OVERWRITEPROMPT|
		OFN_NOCHANGEDIR|
		OFN_LONGNAMES,
		// t@CgqtB^  `[x|gq]
		"DATt@C (*.dat)|*.dat|SẴt@C (*.*)|*.*|",
		// eEBhE
		NULL
	);

	if(cfd.DoModal() == IDOK) {
		// GfBbgRg[Ƀt@CZbg
		CEdit* pEdit = (CEdit *)GetDlgItem( IDC_EDIT7 );
		pEdit->SetWindowText( cfd.GetPathName() );
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonStart
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^OJn
//
//  EXPLANATION
//    j^ȌsAj^OJn
//
//  RETURN
//    j^OJn/s
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::MonStart()
{
	DWORD ret;

	// j^O̊Jn

	// j^OXbhmF
	if(m_pMonitoringThread1) {
		// j^OXbhɊmۂĂꍇ͉ɏI
		return FALSE;
	}

	// j^O摜̐؂oʒuݒ
	m_SingleMonitor.SetCutPos(0, 0);

	// foCXI[v
	if(gggSviControl1.isExist()){
		gggSviControl1.SetBoardNo(1);
		ret = gggSviControl1.SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return FALSE;
		}
	}
	if(gggSviControl2.isExist()){
		gggSviControl2.SetBoardNo(2);
		ret = gggSviControl2.SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return FALSE;
		}
	}
	if(gggSviControl3.isExist()){
		gggSviControl3.SetBoardNo(3);
		ret = gggSviControl3.SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return FALSE;
		}
	}
	if(gggSviControl4.isExist()){
		gggSviControl4.SetBoardNo(4);
		ret = gggSviControl4.SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return FALSE;
		}
	}

	// etO
	m_nMonRate[0]		= 0;	m_nMonRate[1]		= 0;	m_nMonRate[2]		= 0;	m_nMonRate[3]		= 0;
	m_nCamRate[0]		= 0;	m_nCamRate[1]		= 0;	m_nCamRate[2]		= 0;	m_nCamRate[3]		= 0;
	m_nCamLoseRate[0]	= 0;	m_nCamLoseRate[1]	= 0;	m_nCamLoseRate[2]	= 0;	m_nCamLoseRate[3]	= 0;
	m_bMonErr	= FALSE;
	m_bMonStop	= TRUE;

	// obt@
	m_RGBFrame.Release();

	// j^O֘Ã^C}[̃X^[g
	SetTimer(ID_TIMER_MONITORING, TIMER_MONITORING_ELAPSE, NULL);
	SetTimer(ID_TIMER_FRAMERATE, TIMER_FRAMERATE_ELAPSE, NULL);

	if(gggSviControl1.isExist()){
		// j^OXbh̋N
		m_pMonitoringThread1 = AfxBeginThread( MonitoringThread1, this );
		//Xbh̎폜͂Ȃ
		m_pMonitoringThread1->m_bAutoDelete = FALSE;
	}

	if(gggSviControl2.isExist()){
		// j^OXbh̋N
		m_pMonitoringThread2 = AfxBeginThread( MonitoringThread2, this );
		//Xbh̎폜͂Ȃ
		m_pMonitoringThread2->m_bAutoDelete = FALSE;
	}

	if(gggSviControl3.isExist()){
		// j^OXbh̋N
		m_pMonitoringThread3 = AfxBeginThread( MonitoringThread3, this );
		//Xbh̎폜͂Ȃ
		m_pMonitoringThread3->m_bAutoDelete = FALSE;
	}

	if(gggSviControl4.isExist()){
		// j^OXbh̋N
		m_pMonitoringThread4 = AfxBeginThread( MonitoringThread4, this );
		//Xbh̎폜͂Ȃ
		m_pMonitoringThread4->m_bAutoDelete = FALSE;
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonStop
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O~
//
//  EXPLANATION
//    j^O쒆̏ꍇ̓j^O̒~s
//
//  RETURN
//    j^O~/s
//
//  REMARKS
//    j^O̎ct[͓ǂݎ̂Ă
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::MonStop()
{
	// j^O~
	BOOL ret = TRUE;

	// j^O~tOOFF
	m_bMonStop = FALSE;

	// ej^O֘Ã^C}[~
	KillTimer(ID_TIMER_MONITORING);
	KillTimer(ID_TIMER_FRAMERATE);

	// ch1̃j^OXbhmۂĂ邩mF
	if(m_pMonitoringThread1) {
		gggSviControl1.StopMonTimeoutWait();
		// j^OXbh~mF
		DWORD dwExitCode = STILL_ACTIVE;
		int cnt = 0;
		while(dwExitCode == STILL_ACTIVE) {
			//XbhImF
			GetExitCodeThread( m_pMonitoringThread1->m_hThread, &dwExitCode );
			Sleep(DEF_MONTHREAD_WAIT_SEC);
			if(cnt++ > DEF_MONTHREAD_WAIT_CNT) {
				//Xbh̋I
				TerminateThread(m_pMonitoringThread1->m_hThread,-1);
				Sleep(DEF_MONTHREAD_WAIT_SEC);
				ret = FALSE;
				break;
			}
		}
		// j^OXbhj
		delete m_pMonitoringThread1;
		m_pMonitoringThread1 = NULL;
	}

	// ch2̃j^OXbhmۂĂ邩mF
	if(m_pMonitoringThread2) {
		gggSviControl2.StopMonTimeoutWait();
		// j^OXbh~mF
		DWORD dwExitCode = STILL_ACTIVE;
		int cnt = 0;
		while(dwExitCode == STILL_ACTIVE) {
			//XbhImF
			GetExitCodeThread( m_pMonitoringThread2->m_hThread, &dwExitCode );
			Sleep(DEF_MONTHREAD_WAIT_SEC);
			if(cnt++ > DEF_MONTHREAD_WAIT_CNT) {
				//Xbh̋I
				TerminateThread(m_pMonitoringThread2->m_hThread,-1);
				Sleep(DEF_MONTHREAD_WAIT_SEC);
				ret = FALSE;
				break;
			}
		}
		// j^OXbhj
		delete m_pMonitoringThread2;
		m_pMonitoringThread2 = NULL;
	}

	// ch3̃j^OXbhmۂĂ邩mF
	if(m_pMonitoringThread3) {
		gggSviControl3.StopMonTimeoutWait();
		// j^OXbh~mF
		DWORD dwExitCode = STILL_ACTIVE;
		int cnt = 0;
		while(dwExitCode == STILL_ACTIVE) {
			//XbhImF
			GetExitCodeThread( m_pMonitoringThread3->m_hThread, &dwExitCode );
			Sleep(DEF_MONTHREAD_WAIT_SEC);
			if(cnt++ > DEF_MONTHREAD_WAIT_CNT) {
				//Xbh̋I
				TerminateThread(m_pMonitoringThread3->m_hThread,-1);
				Sleep(DEF_MONTHREAD_WAIT_SEC);
				ret = FALSE;
				break;
			}
		}
		// j^OXbhj
		delete m_pMonitoringThread3;
		m_pMonitoringThread3 = NULL;
	}

	// ch4̃j^OXbhmۂĂ邩mF
	if(m_pMonitoringThread4) {
		gggSviControl4.StopMonTimeoutWait();
		// j^OXbh~mF
		DWORD dwExitCode = STILL_ACTIVE;
		int cnt = 0;
		while(dwExitCode == STILL_ACTIVE) {
			//XbhImF
			GetExitCodeThread( m_pMonitoringThread4->m_hThread, &dwExitCode );
			Sleep(DEF_MONTHREAD_WAIT_SEC);
			if(cnt++ > DEF_MONTHREAD_WAIT_CNT) {
				//Xbh̋I
				TerminateThread(m_pMonitoringThread4->m_hThread,-1);
				Sleep(DEF_MONTHREAD_WAIT_SEC);
				ret = FALSE;
				break;
			}
		}
		// j^OXbhj
		delete m_pMonitoringThread4;
		m_pMonitoringThread4 = NULL;
	}

	CFrameData Remainder;

	// ct[ǂݎ̂
	if(gggSviControl1.isExist()){
		// foCXփj^O~𔭍s
		gggSviControl1.MonStop();
		while(gggSviControl1.IsFramePending()) {
			if(gggSviControl1.MonGetHeader(&Remainder) != SVIUSB20_RET_NORMAL) {
				// j^Owb_擾s
				ret = FALSE;
				break;
			}
			if(gggSviControl1.MonGetFrame(&Remainder,m_PicType_1) != SVIUSB20_RET_NORMAL) {
				// j^Ot[擾s
				ret = FALSE;
				break;
			}
		}
		// foCX̃N[Y
		gggSviControl1.SviClose();
	}
	if(gggSviControl2.isExist()){
		// foCXփj^O~𔭍s
		gggSviControl2.MonStop();
		while(gggSviControl2.IsFramePending()) {
			if(gggSviControl2.MonGetHeader(&Remainder) != SVIUSB20_RET_NORMAL) {
				// j^Owb_擾s
				ret = FALSE;
				break;
			}
			if(gggSviControl2.MonGetFrame(&Remainder,m_PicType_2) != SVIUSB20_RET_NORMAL) {
				// j^Ot[擾s
				ret = FALSE;
				break;
			}
		}
		// foCX̃N[Y
		gggSviControl2.SviClose();
	}
	if(gggSviControl3.isExist()){
		// foCXփj^O~𔭍s
		gggSviControl3.MonStop();
		while(gggSviControl3.IsFramePending()) {
			if(gggSviControl3.MonGetHeader(&Remainder) != SVIUSB20_RET_NORMAL) {
				// j^Owb_擾s
				ret = FALSE;
				break;
			}
			if(gggSviControl3.MonGetFrame(&Remainder,m_PicType_3) != SVIUSB20_RET_NORMAL) {
				// j^Ot[擾s
				ret = FALSE;
				break;
			}
		}
		// foCX̃N[Y
		gggSviControl3.SviClose();
	}
	if(gggSviControl4.isExist()){
		// foCXփj^O~𔭍s
		gggSviControl4.MonStop();
		while(gggSviControl4.IsFramePending()) {
			if(gggSviControl4.MonGetHeader(&Remainder) != SVIUSB20_RET_NORMAL) {
				// j^Owb_擾s
				ret = FALSE;
				break;
			}
			if(gggSviControl4.MonGetFrame(&Remainder,m_PicType_4) != SVIUSB20_RET_NORMAL) {
				// j^Ot[擾s
				ret = FALSE;
				break;
			}
		}
		// foCX̃N[Y
		gggSviControl4.SviClose();
	}

	// _uobt@
	m_dbMonDB.Release();
	m_dbMultiMonDB[0].Release();
	m_dbMultiMonDB[1].Release();
	m_dbMultiMonDB[2].Release();
	m_dbMultiMonDB[3].Release();
	return ret;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonitoringThread1
//
//  PARAMETER
//    P32rbgli{֐łCSVIsamDlg|C^j
//
//  SUMMARY
//    CH.1pj^OXbh
//
//  EXPLANATION
//    CH.1pj^Os
//
//  RETURN
//    XbhIR[h
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
UINT CSVIsamDlg::MonitoringThread1(LPVOID pParam)
{
	CSVIsamDlg* pDlg;		// C_CAONX|C^
	CFrameData* pFrame;		// t[f[^NX|C^

	// C_CAÕ|C^擾
	pDlg = (CSVIsamDlg*)pParam;

	// j^O^CAEgݒ
	gggSviControl1.SetMonTimeout(pDlg->m_MonTimeout);

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_OPEN; // Openς

	// j^OJn
	DWORD dwRet;
	if(gggSviControl1.isExist()){
		dwRet = gggSviControl1.MonStart(
							pDlg->m_MonCutSet.nCutX,
							pDlg->m_MonCutSet.nCutY,
							pDlg->m_MonCutSet.nCutW,
							pDlg->m_MonCutSet.nCutH);
		if(dwRet != SVIUSB20_RET_NORMAL) {
			// j^OG[
			pDlg->m_bMonErr = TRUE;
			pDlg->m_bMonStop = FALSE;
			//return 0;
		}
	}

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_START; // MonStartς

	// j^O~tOON̊ԁAj^Os
	while(pDlg->m_bMonStop) {

		if(gggSviControl1.isExist()){
			// _uobt@̋󂫃t[擾
			pFrame = pDlg->m_dbMultiMonDB[0].GetWriteFrame();
			// _uobt@|C^̎擾mF
			if(pFrame) {
				// _uobt@ɋ󂫂ꍇAj^Ot[擾
				// t[擾
				if(gggSviControl1.MonGetData(pFrame,pDlg->m_PicType_1)) {
					// t[擾bN
					pFrame->LockR();
					// t[݃AbN
					pFrame->UnLockW();
				}
				else {
					// t[݃AbN
					pFrame->UnLockW();
					// j^OG[
					pDlg->m_bMonErr = TRUE;
					break;
				}
			}
		}
	}

	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonitoringThread2
//
//  PARAMETER
//    P32rbgli{֐łCSVIsamDlg|C^j
//
//  SUMMARY
//    CH.2pj^OXbh
//
//  EXPLANATION
//    CH.2pj^Os
//
//  RETURN
//    XbhIR[h
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
UINT CSVIsamDlg::MonitoringThread2(LPVOID pParam)
{
	CSVIsamDlg* pDlg;	// C_CAONX|C^
	CFrameData* pFrame;	// t[f[^NX|C^

	// C_CAÕ|C^擾
	pDlg = (CSVIsamDlg*)pParam;

	// j^O^CAEgݒ
	gggSviControl2.SetMonTimeout(pDlg->m_MonTimeout);

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_OPEN; // Openς

	// j^OJn
	DWORD dwRet;
	if(gggSviControl2.isExist()){
		dwRet = gggSviControl2.MonStart(
							pDlg->m_MonCutSet.nCutX,
							pDlg->m_MonCutSet.nCutY,
							pDlg->m_MonCutSet.nCutW,
							pDlg->m_MonCutSet.nCutH);
		if(dwRet != SVIUSB20_RET_NORMAL) {
			// j^OG[
			pDlg->m_bMonErr = TRUE;
			pDlg->m_bMonStop = FALSE;
			//return 0;
		}
	}

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_START; // MonStartς

	// j^O~tOON̊ԁAj^Os
	while(pDlg->m_bMonStop) {

		if(gggSviControl2.isExist()){
			// _uobt@̋󂫃t[擾
			pFrame = pDlg->m_dbMultiMonDB[1].GetWriteFrame();
			// _uobt@|C^̎擾mF
			if(pFrame) {
				// _uobt@ɋ󂫂ꍇAj^Ot[擾
				// t[擾
				if(gggSviControl2.MonGetData(pFrame,pDlg->m_PicType_2)) {
					// t[擾bN
					pFrame->LockR();
					// t[݃AbN
					pFrame->UnLockW();
				}
				else {
					// t[݃AbN
					pFrame->UnLockW();
					// j^OG[
					pDlg->m_bMonErr = TRUE;
					break;
				}
			}
		}

	}

	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonitoringThread3
//
//  PARAMETER
//    P32rbgli{֐łCSVIsamDlg|C^j
//
//  SUMMARY
//    CH.3pj^OXbh
//
//  EXPLANATION
//    CH.3pj^Os
//
//  RETURN
//    XbhIR[h
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
UINT CSVIsamDlg::MonitoringThread3(LPVOID pParam)
{
	CSVIsamDlg* pDlg;	// C_CAONX|C^
	CFrameData* pFrame;	// t[f[^NX|C^

	// C_CAÕ|C^擾
	pDlg = (CSVIsamDlg*)pParam;

	// j^O^CAEgݒ
	gggSviControl3.SetMonTimeout(pDlg->m_MonTimeout);

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_OPEN; // Openς

	// j^OJn
	DWORD dwRet;
	if(gggSviControl3.isExist()){
		dwRet = gggSviControl3.MonStart(
							pDlg->m_MonCutSet.nCutX,
							pDlg->m_MonCutSet.nCutY,
							pDlg->m_MonCutSet.nCutW,
							pDlg->m_MonCutSet.nCutH);
		if(dwRet != SVIUSB20_RET_NORMAL) {
			// j^OG[
			pDlg->m_bMonErr = TRUE;
			pDlg->m_bMonStop = FALSE;
			//return 0;
		}
	}

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_START; // MonStartς

	// j^O~tOON̊ԁAj^Os
	while(pDlg->m_bMonStop) {

		if(gggSviControl3.isExist()){
			// _uobt@̋󂫃t[擾
			pFrame = pDlg->m_dbMultiMonDB[2].GetWriteFrame();
			// _uobt@|C^̎擾mF
			if(pFrame) {
				// _uobt@ɋ󂫂ꍇAj^Ot[擾
				// t[擾
				if(gggSviControl3.MonGetData(pFrame,pDlg->m_PicType_3)) {
					// t[擾bN
					pFrame->LockR();
					// t[݃AbN
					pFrame->UnLockW();
				}
				else {
					// t[݃AbN
					pFrame->UnLockW();
					// j^OG[
					pDlg->m_bMonErr = TRUE;
					break;
				}
			}
		}

	}

	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonitoringThread4
//
//  PARAMETER
//    P32rbgli{֐łCSVIsamDlg|C^j
//
//  SUMMARY
//    CH.4pj^OXbh
//
//  EXPLANATION
//    CH.4pj^Os
//
//  RETURN
//    XbhIR[h
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
UINT CSVIsamDlg::MonitoringThread4(LPVOID pParam)
{
	CSVIsamDlg* pDlg;	// C_CAONX|C^
	CFrameData* pFrame;	// t[f[^NX|C^

	// C_CAÕ|C^擾
	pDlg = (CSVIsamDlg*)pParam;

	// j^O^CAEgݒ
	gggSviControl4.SetMonTimeout(pDlg->m_MonTimeout);

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_OPEN; // Openς

	// j^OJn
	DWORD dwRet;
	if(gggSviControl4.isExist()){
		dwRet = gggSviControl4.MonStart(
							pDlg->m_MonCutSet.nCutX,
							pDlg->m_MonCutSet.nCutY,
							pDlg->m_MonCutSet.nCutW,
							pDlg->m_MonCutSet.nCutH);
		if(dwRet != SVIUSB20_RET_NORMAL) {
			// j^OG[
			pDlg->m_bMonErr = TRUE;
			pDlg->m_bMonStop = FALSE;
			//return 0;
		}
	}

	// j^OԃtOݒ
	pDlg->m_MonState = DEF_MON_START; // MonStartς

	// j^O~tOON̊ԁAj^Os
	while(pDlg->m_bMonStop) {

		if(gggSviControl4.isExist()){
			// _uobt@̋󂫃t[擾
			pFrame = pDlg->m_dbMultiMonDB[3].GetWriteFrame();
			// _uobt@|C^̎擾mF
			if(pFrame) {
				// _uobt@ɋ󂫂ꍇAj^Ot[擾
				// t[擾
				if(gggSviControl4.MonGetData(pFrame,pDlg->m_PicType_4)) {
					// t[擾bN
					pFrame->LockR();
					// t[݃AbN
					pFrame->UnLockW();
				}
				else {
					// t[݃AbN
					pFrame->UnLockW();
					// j^OG[
					pDlg->m_bMonErr = TRUE;
					break;
				}
			}
		}
	}

	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnTimer
//
//  PARAMETER
//    TIMER ID
//
//  SUMMARY
//    ^C}[
//
//  EXPLANATION
//    ^C}[ɂes
//
//  RETURN
//    NONE
//
//  REMARKS
//    ^C}[ɂs̓j^Ot[̕`At[[g\A
//    R[fBOACtH[V̐ݒłB
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == ID_TIMER_MONITORING) {
		// j^Ot[̕`
		if(!MonDraw()) {
			MonStop();
		}
	}
	else if(nIDEvent == ID_TIMER_FRAMERATE) {
		// t[[g
		FrameRate();
	}

	CDialog::OnTimer(nIDEvent);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    MonDraw
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^Ot[\
//
//  EXPLANATION
//    ΏۂƂȂ摜\GAփj^Ot[\
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::MonDraw()
{

	// j^O^C}[
	if(m_bMonErr) {

		// j^OɃG[Ăꍇ́A
		// j^O~
		MonStop();

		// {^ԂύX
		((CButton*)GetDlgItem(IDC_MS1))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_OP3))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_OP4))->EnableWindow(TRUE);

		// G[bZ[W̕\
		AfxMessageBox(IDS_ERR_MONITORING);
	}
	else {
		for(int i = 0 ; i < MULTI_MONITOR ; i++) {
			switch(i){
				case 0: if(!gggSviControl1.isExist()) continue; else break;
				case 1: if(!gggSviControl2.isExist()) continue; else break;
				case 2: if(!gggSviControl3.isExist()) continue; else break;
				case 3: if(!gggSviControl4.isExist()) continue; else break;
			}
			CFrameData* pFrame = m_dbMultiMonDB[i].GetReadFrame();
			int FrameDataSize = 0;
			if(pFrame) {
				// 擾t[c0ȏ̃TCY邩mF
				if(pFrame->GetWidth() != 0 && pFrame->GetHeight() != 0) {
					int FrameWidth = pFrame->GetWidth();
					int FrameHight = pFrame->GetHeight();
					// t[f[^TCYvZ
					FrameDataSize = FrameWidth * FrameHight * 3;
					// TCYقȂꍇARGBobt@̍Ċmۂs
					if(m_RGBFrame.GetWidth() != FrameWidth
						|| m_RGBFrame.GetHeight() != FrameHight) {
						// RGBobt@Ċm
						m_RGBFrame.ReservBuffer(FrameDataSize);
						m_RGBFrame.SetFrameLen(m_RGBFrame.GetBufferSize());
						m_RGBFrame.SetMonHeader(pFrame->GetMonHeader());
					}
					// YUV422f[^24rbgRGBf[^֕ϊ
					CString csSize;
					switch(i){
						case 0:
							YUVtoRGB(
								m_RGBFrame.GetFramePointer(),
								pFrame->GetFramePointer(),
								FrameWidth,
								FrameHight,
								m_PicType_1);
							// t[TCY̕\
							csSize.Format("%d x %d", m_RGBFrame.GetWidth(), m_RGBFrame.GetHeight());
							((CEdit*)GetDlgItem(IDC_FRAMESIZE_1))->SetWindowText(csSize);
							break;
						case 1:
							YUVtoRGB(
								m_RGBFrame.GetFramePointer(),
								pFrame->GetFramePointer(),
								FrameWidth,
								FrameHight,
								m_PicType_2);
							// t[TCY̕\
							csSize.Format("%d x %d", m_RGBFrame.GetWidth(), m_RGBFrame.GetHeight());
							((CEdit*)GetDlgItem(IDC_FRAMESIZE_2))->SetWindowText(csSize);
							break;
						case 2:
							YUVtoRGB(
								m_RGBFrame.GetFramePointer(),
								pFrame->GetFramePointer(),
								FrameWidth,
								FrameHight,
								m_PicType_3);
							// t[TCY̕\
							csSize.Format("%d x %d", m_RGBFrame.GetWidth(), m_RGBFrame.GetHeight());
							((CEdit*)GetDlgItem(IDC_FRAMESIZE_3))->SetWindowText(csSize);
							break;
						case 3:
							YUVtoRGB(
								m_RGBFrame.GetFramePointer(),
								pFrame->GetFramePointer(),
								FrameWidth,
								FrameHight,
								m_PicType_4);
							// t[TCY̕\
							csSize.Format("%d x %d", m_RGBFrame.GetWidth(), m_RGBFrame.GetHeight());
							((CEdit*)GetDlgItem(IDC_FRAMESIZE_4))->SetWindowText(csSize);
							break;
					}

					// Jt[[g擾
					m_nCamRate[i] = pFrame->GetMonHeader().ulFrameRate;
					// Jt[j[g擾
					m_nCamLoseRate[i] += pFrame->GetMonHeader().ulLoseFrame;
					// j^O_uobt@̃AbN
					pFrame->UnLockR();

					if(IsSMon() && m_selid == i) {
						// 摜\GARGBf[^ݒ
#if 1 // 摜\GA̕\OFFɂĂ݂
						m_SingleMonitor.SetFrame(&m_RGBFrame);
#endif // 摜\GA̕\OFFɂĂ݂
					}

#if 1 // TlC摜\̕\OFFɂĂ݂
					// }`[h̏ꍇ̉摜\GAւRGBf[^ݒ
					m_MultiMonitor[i].SetZoom(0.25);
					m_MultiMonitor[i].SetFrame(&m_RGBFrame);
#endif // TlC摜\̕\OFFɂĂ݂
					// j^O\JE^1
					m_nMonRate[i]++;
				}
			}
			else if(!m_bMonStop) {
				// j^O~Ԃłj^Ot[_uobt@
				// cĂȂꍇAct[\I
				return FALSE;
			}
		}
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    FrameRate
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    t[[g\
//
//  EXPLANATION
//    t[[g̕\s
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::FrameRate()
{
	// t[[gvZE\^C}[

	// t[[gvZ
	CString csRate;	// t[[g\
	double dCamRate;	// Jt[[g
	double dAplBuff;	// AvP[Vt[[g

	// Jt[[ǧvZ
	dCamRate = (double)m_nCamRate[0]/100;

	// AvP[Vt[[ǧvZ
	dAplBuff = (m_nMonRate[0] == 0) ? 0.0 : dCamRate * m_nMonRate[0] / (m_nCamLoseRate[0] + m_nMonRate[0]);

	// \镶쐬
	csRate.Format("%0.2f / %0.2f", dAplBuff, dCamRate);

	// e[g0ɏ
	m_nMonRate[0]		= 0;	m_nMonRate[1]		= 0;	m_nMonRate[2]		= 0;	m_nMonRate[3]		= 0;
	m_nCamRate[0]		= 0;	m_nCamRate[1]		= 0;	m_nCamRate[2]		= 0;	m_nCamRate[3]		= 0;
	m_nCamLoseRate[0]	= 0;	m_nCamLoseRate[1]	= 0;	m_nCamLoseRate[2]	= 0;	m_nCamLoseRate[3]	= 0;

	// EBhE^Cgݒ
	CString csDlgTitle;
	csDlgTitle.Format("SVIsam4_Lite Ver.");
	csDlgTitle += GetProductVersion();
	csDlgTitle += " - ";
	csDlgTitle += csRate;
	this->SetWindowText(csDlgTitle);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    YUVtoRGB
//
//  PARAMETER
//    LPBYTE lpRGB : RGB24rbg̃f[^i[obt@
//    LPBYTE lpYUV : YUV422f[^i[Ăobt@
//    int nW : t[f[^̕
//    int nH : t[f[^̍
//
//  SUMMARY
//    YUV422RGB24rbgւ̕ϊ
//
//  EXPLANATION
//    YUV422f[^RGB24rbgf[^ւ̕ϊs
//
//  RETURN
//    NONE
//
//  REMARKS
//    ϊꂽRGBf[^ɃpfBO͂܂
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::YUVtoRGB(LPBYTE lpRGB, LPBYTE lpYUV, int nW, int nH, int nType)
{
	int x;	// XJE^
	int y;	// YJE^
	int nRGBOffset;	// RGBItZbg
	LPBYTE lpRGBpt, lpYUVpt;	// RGB, YUVobt@|C^
	int Y1, U, V, Y2;	// YUVf[^|C^
	int nY;	// PxMvZϐ
	int nLine = nW * 3;	// 24rbgRGB1C

	// obt@|C^i[
	lpYUVpt = lpYUV;
	// RGBItZbgvZ
	nRGBOffset = nW * (nH - 1) * 3;

	int Y0offset = 1;			// UYVYY0ItZbgʒu
	int Y1offset = 3;			// UYVYY1ItZbgʒu
	int Voffset  = 2;			// UYVYVItZbgʒu
	int Uoffset  = 0;			// UYVYUItZbgʒu

	if(nType == YUY2 || nType == YUY216)
	{
		Y0offset = 0;			// YUY2Y0ItZbgʒu
		Y1offset = 2;			// YUY2Y1ItZbgʒu
		Voffset  = 3;			// YUY2VItZbgʒu
		Uoffset  = 1;			// YUY2UItZbgʒu
	}

	// YUV|C^ItZbgʒu擾
	int plus = 4;

	// YUV->RGBϊ[v
	for(y = 0 ; y < nH ; y++) {
		lpRGBpt = lpRGB + nRGBOffset;
		for(x = 0 ; x < nW ; x+=2) {
			// YUVl擾
			U  = *(lpYUVpt + Uoffset);
			Y1 = *(lpYUVpt + Y0offset);
			V  = *(lpYUVpt + Voffset);
			Y2 = *(lpYUVpt + Y1offset);
			// |C^ʒuړ
			lpYUVpt += plus;

			// 2l\
			if(m_bBinarizationFlag == TRUE){
				if(Y1 > m_iBinarization_Thres){
					Y1 = 255;
				}else{
					Y1 = 0;
				}
				if(Y2 > m_iBinarization_Thres){
					Y2 = 255;
				}else{
					Y2 = 0;
				}
				U  = 128;
				V  = 128;
			}

			// YVF[fBO␳
			if(m_bLensShadingFlag == TRUE){
				int yval = Y1 % m_iLensShading_Step;
				yval = Y1 - yval;
				if(yval > m_iLensShading_Thres){
					Y1 = 75;
					U = 86;
					V = 255;
				}else{
					Y1 = yval;
					U = 128;
					V = 128;
				}
				yval = Y2 % m_iLensShading_Step;
				yval = Y2 - yval;
				if(yval > m_iLensShading_Thres){
					Y2 = 75;
					U = 86;
					V = 255;
				}else{
					Y2 = yval;
					U = 128;
					V = 128;
				}
			}

			// 1Ԗڂ̋PxMɌvẐ߂̃ItZbg
			nY = Y1 * YUV_OFFSET;

			// Y1UV->RGB
			lpRGBpt = YUV(lpRGBpt, nY, U, V);

			// 2Ԗڂ̋PxMɌvẐ߂̃ItZbg
			nY = Y2 * YUV_OFFSET;

			// Y2UV->RGB
			lpRGBpt = YUV(lpRGBpt, nY, U, V);
		}

		// RGBobt@ItZbgʒuvZ
		nRGBOffset -= nLine;
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnDestroy
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    EBhEjʒm
//
//  EXPLANATION
//    EBhEjۂɌĂяo܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    EBhEjۂ̃AvP[VIs܂
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// j^OsĂꍇ̓j^O~
	MonStop();

	// INIt@C֐ݒ
	WriteIniCutout();
	WriteIniPicType();
	// j^O[hۑ
	WriteIniMonMode();
	// Jݒ̏ۑ
	WriteIniMultipleTransfer();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ShowMon
//
//  PARAMETER
//    BOOL bShow : 摜\[h(TREE:VOj^[[hAFALSE:}`j^[[h)
//
//  SUMMARY
//    摜\GA؂ւ
//
//  EXPLANATION
//    摜\GA̐؂ւs܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ShowMon(BOOL bShow)
{
	// VOj^Op摜\GA̕\

	// j^O[hύX
	SetSMon();

	// VOj^Op摜\
	m_SingleMonitor.ShowWindow(SW_SHOW);

	// 
	m_SingleMonitor.Initialize();

	// TlCj^N摜\GA\
	for(int i = 0 ; i < MULTI_MONITOR ; i++) {
		m_MultiMonitor[i].ShowWindow(SW_SHOW);
		m_MultiMonitor[i].Initialize();
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    BitmapSave
//
//  PARAMETER
//    CString csBmpPath : rbg}bvt@CpX
//    CFrameData* pRGBFrame : ۑRGBCFrameDataNX|C^
//
//  SUMMARY
//    rbg}bvۑ
//
//  EXPLANATION
//    w肳ꂽt@CpX24BITrbg}bvt@C̕ۑs܂
//
//  RETURN
//    t@CۑmF
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::BitmapSave(CString csBmpPath, CFrameData* pRGBFrame)
{
	// rbg}bvt@C̍쐬

	BITMAPFILEHEADER	BitmapFileHeader;	// rbg}bvwb_
	BITMAPINFO			BitmapInfo;	// rbg}bvCtH

	// rbg}bvwb_쐬
	BitmapFileHeader.bfType				= 0x4d42;
	BitmapFileHeader.bfSize				= pRGBFrame->GetFrameLen() + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFO);
	BitmapFileHeader.bfReserved1		= 0;
	BitmapFileHeader.bfReserved2		= 0;
	BitmapFileHeader.bfOffBits			= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFO);

	// rbg}bvCtH쐬
	BitmapInfo.bmiHeader.biSize				= sizeof(BITMAPINFOHEADER);
	BitmapInfo.bmiHeader.biWidth			= pRGBFrame->GetWidth();
	BitmapInfo.bmiHeader.biHeight			= pRGBFrame->GetHeight();
	BitmapInfo.bmiHeader.biPlanes			= 1;
	BitmapInfo.bmiHeader.biBitCount			= 24;
	BitmapInfo.bmiHeader.biCompression		= BI_RGB;
	BitmapInfo.bmiHeader.biSizeImage		= pRGBFrame->GetFrameLen();
	BitmapInfo.bmiHeader.biXPelsPerMeter	= 1;
	BitmapInfo.bmiHeader.biYPelsPerMeter	= 1;
	BitmapInfo.bmiHeader.biClrUsed			= 0;
	BitmapInfo.bmiHeader.biClrImportant		= 0;

	// t@C
	try{
		int nW;		// 摜i24rbgj
		int nPad;	// 摜pfBO
		int nFile;	// 摜t@CTCY

		// 摜vZ
		nW = pRGBFrame->GetWidth() * 3;

		// pfBOvZ
		nPad = ((nW % 4) == 0)?0 : 4 - (nW % 4);

		// t@CTCYvZ
		nFile = nW + nPad;
		nFile *= pRGBFrame->GetHeight();

		// obt@m
		LPBYTE lpBmpFile = new BYTE[nFile];
		LPBYTE lpBmp = lpBmpFile;
		LPBYTE lpRGB = pRGBFrame->GetFramePointer();

		// pfBOl24rbgRGBf[^쐬
		int nY;
		for(nY = 0 ; nY < pRGBFrame->GetHeight() ; nY++) {
			memcpy(lpBmp, lpRGB, nW);
			lpBmp += nW + nPad;
			lpRGB += nW;
		}

		// t@C쐬
		CFile	File(csBmpPath, CFile::modeCreate | CFile::modeWrite);	// CFileIuWFNg

		File.Write(&BitmapFileHeader, sizeof(BitmapFileHeader));	// BITMAPFILEHEADER
		File.Write(&BitmapInfo, sizeof(BitmapInfo));	// BITMAPINFO

		File.Write(lpBmpFile, nFile);	// RGBf[^

		File.Close();

		// obt@̉
		delete [] lpBmpFile;
	}
	catch(CFileException* e) {
		// t@CIOG[
		AfxMessageBox(IDS_ERR_SAVEBMP);
		e->Delete();
		return FALSE;
	}
	catch(CMemoryException* e) {
		// G[
		CString csMsg;
		csMsg.Format("Error memory damege. \npath %s", csBmpPath);
		TRACE(csMsg);
		AfxMessageBox(IDS_ERR_SAVEBMP);
		e->Delete();
		return FALSE;
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniCutout
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ؂oݒ擾
//
//  EXPLANATION
//    INIt@C؂oݒɂĂ̏擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniCutout()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[
	CRect SgRect;	// }`摜\GATCY

	// j^O̐؂oʒu擾
	m_MonCutSet.nCutX	= IniCntl.ReadInt(DEF_INI_KEY_CUTX, DEF_INIT_CUTX);
	m_MonCutSet.nCutY	= IniCntl.ReadInt(DEF_INI_KEY_CUTY, DEF_INIT_CUTY);
	m_MonCutSet.nCutW	= IniCntl.ReadInt(DEF_INI_KEY_CUTW, DEF_INIT_CUTW);
	m_MonCutSet.nCutH	= IniCntl.ReadInt(DEF_INI_KEY_CUTH, DEF_INIT_CUTH);

	// VOj^O摜\GÃTCY擾
	m_SingleMonitor.GetWindowRect(&SgRect);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    WriteIniCutout
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ؂oݒۑ
//
//  EXPLANATION
//    INIt@Cɐ؂oݒɂĂ̏ۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::WriteIniCutout()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// j^O̐؂oʒu擾
	IniCntl.WriteInt(DEF_INI_KEY_CUTX, m_MonCutSet.nCutX);
	IniCntl.WriteInt(DEF_INI_KEY_CUTY, m_MonCutSet.nCutY);
	IniCntl.WriteInt(DEF_INI_KEY_CUTW, m_MonCutSet.nCutW);
	IniCntl.WriteInt(DEF_INI_KEY_CUTH, m_MonCutSet.nCutH);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniPicTyep
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    PictureTyepݒ擾
//
//  EXPLANATION
//    INIt@C PictureTyep擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniPicType()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// PictureType擾
	m_PicType_1 = IniCntl.ReadInt(DEF_INI_KEY_INFO_PICTYPE_1, DEF_INIT_PICTURETYEP);
	m_PicType_2 = IniCntl.ReadInt(DEF_INI_KEY_INFO_PICTYPE_2, DEF_INIT_PICTURETYEP);
	m_PicType_3 = IniCntl.ReadInt(DEF_INI_KEY_INFO_PICTYPE_3, DEF_INIT_PICTURETYEP);
	m_PicType_4 = IniCntl.ReadInt(DEF_INI_KEY_INFO_PICTYPE_4, DEF_INIT_PICTURETYEP);

	// Input VSync Invert擾
	m_VSNeg_1 = IniCntl.ReadInt(DEF_INI_KEY_INFO_VSNEG_1, DEF_INIT_VSNEG);
	m_VSNeg_2 = IniCntl.ReadInt(DEF_INI_KEY_INFO_VSNEG_2, DEF_INIT_VSNEG);
	m_VSNeg_3 = IniCntl.ReadInt(DEF_INI_KEY_INFO_VSNEG_3, DEF_INIT_VSNEG);
	m_VSNeg_4 = IniCntl.ReadInt(DEF_INI_KEY_INFO_VSNEG_4, DEF_INIT_VSNEG);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    WriteIniPicType
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//     PictureTyepݒۑ
//
//  EXPLANATION
//    INIt@C PictureTyepۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::WriteIniPicType()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// PictureTypeۑ
	IniCntl.WriteInt(DEF_INI_KEY_INFO_PICTYPE_1, m_PicType_1);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_PICTYPE_2, m_PicType_2);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_PICTYPE_3, m_PicType_3);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_PICTYPE_4, m_PicType_4);

	// Input VSync Invertۑ
	IniCntl.WriteInt(DEF_INI_KEY_INFO_VSNEG_1, m_VSNeg_1);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_VSNEG_2, m_VSNeg_2);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_VSNEG_3, m_VSNeg_3);
	IniCntl.WriteInt(DEF_INI_KEY_INFO_VSNEG_4, m_VSNeg_4);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniSetButtonName
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [U[{^INIt@Cǂݍ݉ʂ֔f
//
//  EXPLANATION
//    [U[{^INIt@Cǂݍ݉ʂ֔f
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniSetButtonName()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	char btn_name[32];

	// Button8̖̂擾
	IniCntl.ReadString(DEF_INI_KEY_USERBTN_8, DEF_INIT_USERBTN_8, btn_name,	32);
	((CButton*)GetDlgItem(IDC_BUTTON8))->SetWindowText(btn_name);

	// Button9̖̂擾
	IniCntl.ReadString(DEF_INI_KEY_USERBTN_9, DEF_INIT_USERBTN_9, btn_name,	32);
	((CButton*)GetDlgItem(IDC_BUTTON9))->SetWindowText(btn_name);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniBoardNo
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    BoardNo.ݒ擾
//
//  EXPLANATION
//    INIt@C SVI-03 Board Number擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniBoardNo()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// BoardNo.擾
	m_BoardNo = IniCntl.ReadInt(DEF_INI_KEY_BOARDNO, DEF_INIT_BOARDNO);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnMouseMove
//
//  PARAMETER
//    UINT nFlags : zL[
//    CPoint point : }EX|WV
//
//  SUMMARY
//    }EXړ
//
//  EXPLANATION
//    }EXړ擾AJ[o[֔f
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// }EXړ

	// J[o[ݒ菈R[
	ColorBar(point);

	CDialog::OnMouseMove(nFlags, point);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ColorBar
//
//  PARAMETER
//    CPoint MousePoint : }EX|WV
//
//  SUMMARY
//    J[o[
//
//  EXPLANATION
//    }EXʒu摜Ŏw肳ꂽsNZ̐F擾
//
//  RETURN
//    
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::ColorBar(CPoint MousePoint)
{
	// J[o[ݒ菈

	if(!m_pSVIcbDlg) {
		// J[o[̏ꍇ
		return FALSE;
	}

	DWORD dwRGB, dwYUV;	// RGByYUVli[ϐ
	CRect MainPos, MonPos;	// C_CAOyщ摜\GÃVXeW
	CPoint ImagePoint;	// 摜̐΍W

	// J[o[̐ݒ
	this->GetWindowRect(&MainPos);
	m_SingleMonitor.GetWindowRect(&MonPos);

	// _CAÖʒu擾
	MonPos.top -= (MainPos.top + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYEDGE));
	MonPos.left -= (MainPos.left + GetSystemMetrics(SM_CXEDGE));
	MonPos.bottom -= (MainPos.top + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYEDGE));
	MonPos.right -= (MainPos.left + GetSystemMetrics(SM_CXEDGE));
	// VOj^O摜\GAɃ}EXݒ肳Ă
	if((MousePoint.x > MonPos.left && MousePoint.x < MonPos.right)
		&& (MousePoint.y > MonPos.top && MousePoint.y < MonPos.bottom)) {
		// 摜̐΍WvZ
		ImagePoint = MousePoint - CPoint(MonPos.left, MonPos.top);
		// ΍WF擾
		if(GetPixelColor(&ImagePoint, &dwRGB, &dwYUV)) {
			// ɐF񂪎擾ꂽꍇAJ[o[֐ݒ肷
			m_pSVIcbDlg->SetPoint(ImagePoint);
			m_pSVIcbDlg->SetRGB(dwRGB);
			m_pSVIcbDlg->SetYUV(dwYUV);
		}
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetPixelColor
//
//  PARAMETER
//    CPoint* pMousePoint : }EX|WV
//    DWORD* pdwRGB : RGBsNZJ[ [0x00RRGGBB `ŕۑ]
//    DWORD* pdwYUV : YUVsNZJ[ [0x00YYUUVV `ŕۑ]
//
//  SUMMARY
//    sNZJ[擾
//
//  EXPLANATION
//    }EXʒusNZ肵F߂
//
//  RETURN
//    F擾
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::GetPixelColor(CPoint* pMousePoint, DWORD* pdwRGB, DWORD* pdwYUV)
{
	pMousePoint->x = pMousePoint->x;
	pMousePoint->y = pMousePoint->y;

	// }EX|WV摜͈͓Ŏ܂邩mF
	if(!(pMousePoint->x > 0 && pMousePoint->x <= m_RGBFrame.GetWidth())) {
		// ܂Ȃꍇ
		return FALSE;
	}
	if(!(pMousePoint->y > 0 && pMousePoint->y <= m_RGBFrame.GetHeight())) {
		// c܂Ȃꍇ
		return FALSE;
	}

	// }EX|WVRGBl擾
	int nOffset = (m_RGBFrame.GetWidth() * 3) * (m_RGBFrame.GetHeight() - pMousePoint->y) + (pMousePoint->x - 1) * 3;
	LPBYTE pRGB = m_RGBFrame.GetFramePointer() + nOffset;
	*pdwRGB = (*(pRGB + 2)<<16)|(*(pRGB + 1)<<8)|*pRGB;

	// YUV߂
	int nY =  (int)((299 * *(pRGB + 2) + 587 * *(pRGB + 1) + 114 * *pRGB)/1000);
	if(nY > 255) nY = 255;
	else if(nY < 0) nY = 0;
	int nU = (int)((-169 * *(pRGB + 2) - 331 * *(pRGB + 1) + 500 * *pRGB)/1000) + 128;
	if(nU > 255) nU = 255;
	else if(nU < 0) nU = 0;
	int nV =  (int)((500 * *(pRGB + 2) - 419 * *(pRGB + 1) - 81 * *pRGB)/1000) + 128;
	if(nV > 255) nV = 255;
	else if(nV < 0) nV = 0;
	*pdwYUV = (nY<<16)|(nU<<8)|nV;

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    Information
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    CtH[V
//
//  EXPLANATION
//    foCXXe[^X擾Rg[֔f
//
//  RETURN
//    
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::Information()
{
	// CtH[V

	GET_STATUS SviSts;	// SVIXe[^X
	DWORD ret;			// ^[R[h
	BOOL bOpen = FALSE;	// foCXI[vtO
	CString csString;	// i[ϐ
	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	// foCX̃I[v
	if(pControl->IsClose()) {
		pControl->SetBoardNo(m_selid+1);
		ret = pControl->SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			// ^C}[N̏ꍇ̓^C}[~
			CString st;
			st.Format("Informatin read oprn error %08X", ret);
			AfxMessageBox(st);
			AfxMessageBox(IDS_ERR_INFO);
			TRACE("Information : SviOpen ret[%08X]\n", ret);
			return FALSE;
		}
		bOpen = TRUE;
	}

	// tXe[^X擾
	ret = pControl->GetSviStatus(&SviSts);
	if(ret != SVIUSB20_RET_NORMAL) {
		AfxMessageBox(IDS_ERR_INFO2);
		TRACE("Information : GetStatus ret[%08X]\n", ret);
		return FALSE;
	}

	unsigned char cbuf[6];
	int boardver, pllkhz;
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	ULONG ulSubAdr = 0x9; // SVI-board I2C register sub address
	DSPBlockRead(ulSlaveAdr, ulSubAdr, 0x0, 0x6, cbuf);
	boardver = (int)cbuf[0] & 0xff;
	pllkhz   = ((((int)cbuf[4]<<24)&0xff000000) | (((int)cbuf[3]<<16)&0xff0000) | (((int)cbuf[2]<<8)&0xff00) | ((int)cbuf[1]&0xff));
	csString.Format("%02d", boardver);
	((CEdit*)GetDlgItem(IDC_BOARDVER))->SetWindowText(csString);
	csString.Format("%06d", pllkhz);
	((CEdit*)GetDlgItem(IDC_PLL))->SetWindowText(csString);

	if(bOpen) {
		// foCX̃N[Y
		pControl->SviClose();
	}

	// Rg[֐ݒ肷

	// StatusBA
	csString.Format("%d", SviSts.ulBasicStatus);
	((CEdit*)GetDlgItem(IDC_STS_BA))->SetWindowText(csString);

	// StatusOP
	csString.Format("%d", SviSts.ulOPStatus);
	((CEdit*)GetDlgItem(IDC_STS_OP))->SetWindowText(csString);

	// OrgSizeW
	csString.Format("%d", SviSts.ulOrgSizeW);
	((CEdit*)GetDlgItem(IDC_ORGW))->SetWindowText(csString);

	// OrgSizeH
	csString.Format("%d", SviSts.ulOrgSizeH);
	((CEdit*)GetDlgItem(IDC_ORGH))->SetWindowText(csString);

	// CutX
	csString.Format("%d", SviSts.ulCutout_x);
	((CEdit*)GetDlgItem(IDC_CUTX))->SetWindowText(csString);

	// CutY
	csString.Format("%d", SviSts.ulCutout_y);
	((CEdit*)GetDlgItem(IDC_CUTY))->SetWindowText(csString);

	// CutW
	csString.Format("%d", SviSts.ulCutSizeW);
	((CEdit*)GetDlgItem(IDC_CUTW))->SetWindowText(csString);

	// CutH
	csString.Format("%d", SviSts.ulCutSizeH);
	((CEdit*)GetDlgItem(IDC_CUTH))->SetWindowText(csString);

	if(m_pMonitoringThread1) {
		// MonSizeW
		csString.Format("%d", m_RGBFrame.GetMonHeader().ulMonSizeW);
		((CEdit*)GetDlgItem(IDC_MONW))->SetWindowText(csString);
		// MonSizeH
		csString.Format("%d", m_RGBFrame.GetMonHeader().ulMonSizeH);
		((CEdit*)GetDlgItem(IDC_MONH))->SetWindowText(csString);
	}
	else {
		// MonSizeW
		((CEdit*)GetDlgItem(IDC_MONW))->SetWindowText("");
		// MonSizeH
		((CEdit*)GetDlgItem(IDC_MONH))->SetWindowText("");
	}

	// FPGA Version
	csString.Format("%x", SviSts.ulHWVersion);
	double fw = atof(csString) / 100;
	csString.Format("%.02f", fw);
	((CEdit*)GetDlgItem(IDC_HWVER))->SetWindowText(csString);

	// FIRM Version
	csString.Format("%x", SviSts.ulFWVersion);
	double hw = atof(csString) / 100;
	csString.Format("%.02f", hw);
	((CEdit*)GetDlgItem(IDC_FWVER))->SetWindowText(csString);

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnInfoup
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [Refresh]{^NbN
//
//  EXPLANATION
//    [Refresh]{^NbNꂽۂɃCtH[Vs
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnInfoup()
{
	// CtH[VsARg[̒lXV
	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;
	Information();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnOp4
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    Jp[On/Off{^
//
//  EXPLANATION
//    Jp[ON/OFF؂ւ֐̌Ăяo
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnOp4()
{
	// JdON/OFF
	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;
	CamPower();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CamPower
//
//  PARAMETER
//    BOOL bCamCheck : Only camera power check
//
//  SUMMARY
//    Jp[On/Off
//
//  EXPLANATION
//    Jp[ON/OFF؂ւ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::CamPower(BOOL bCamCheck)
{
	// Jp[WX^[h

	CString csLabel;	// {^x
	BYTE dwRead;	// Read value
	BYTE dwWrite;	// Write value
	DWORD ret;	// Device return code
	BOOL result;	// Function return code
	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	if(m_pMonitoringThread1) {
		// j^Ȍꍇ̓j^OI
		MonStop();
		// {^OFFɂ
		((CButton*)GetDlgItem(IDC_MS1))->SetCheck(FALSE);
		((CButton*)GetDlgItem(IDC_MS5))->SetCheck(FALSE);
	}

	// foCXI[v
	pControl->SetBoardNo(m_selid+1);
	ret = pControl->SviOpen();
	if(ret != SVIUSB20_RET_NORMAL) {
		// foCXI[vs
		AfxMessageBox(IDS_ERR_SVI_OPEN);
		return FALSE;
	}

	// I2C one byte read
	ret = DSPBlockRead( DEF_SLV_ID, DEF_ADR_CAMPW, 0, 1, &dwRead );
	if(ret != SVIUSB20_RET_NORMAL) {
		// Read s
		AfxMessageBox(IDS_ERR_I2C_RDBYTE);
		return FALSE;
	}

	// foCXN[Y
	ret = pControl->SviClose();
	if(ret != SVIUSB20_RET_NORMAL) {
		// N[Ys
		AfxMessageBox(IDS_ERR_SVI_CLOSE);
		return FALSE;
	}

	if(bCamCheck) {
		// Jp[ԃ`FbN
		return (dwRead&DEF_CAM_PW_ON)?TRUE:FALSE;
	}

	// Jp[ԊmF
	if(dwRead&DEF_CAM_PW_ON) {
		// {^ONԁiJp[ONj
		// JWX^ ON->OFF
		dwWrite = dwRead&DEF_CAM_PW_OFF;
		csLabel.LoadString(IDS_CAM_PWON);
		result = FALSE;
	}
	else {
		// {^OFFԁiJp[OFFj
		// JWX^ OFF->ON
		dwWrite = dwRead|DEF_CAM_PW_ON;
		csLabel.LoadString(IDS_CAM_PWOFF);
		result = TRUE;
	}

	// foCXI[v
	pControl->SetBoardNo(m_selid+1);
	ret = pControl->SviOpen();
	if(ret != SVIUSB20_RET_NORMAL) {
		// foCXI[vs
		AfxMessageBox(IDS_ERR_SVI_OPEN);
		return FALSE;
	}

	// I2C one byte read
	ret = DSPBlockWrite( DEF_SLV_ID, DEF_ADR_CAMPW, 0, 1, &dwWrite );
	if(ret != SVIUSB20_RET_NORMAL) {
		// Write s
		AfxMessageBox(IDS_ERR_I2C_WTBYTE);
		return FALSE;
	}

	// foCXN[Y
	ret = pControl->SviClose();
	if(ret != SVIUSB20_RET_NORMAL) {
		// N[Ys
		AfxMessageBox(IDS_ERR_SVI_CLOSE);
		return FALSE;
	}

	// {^xύX
	((CButton*)GetDlgItem(IDC_OP4))->SetWindowText(csLabel);

	return result;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetProductVersion
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    AvP[Vv_Ngo[W擾
//
//  EXPLANATION
//    AvP[V̐io[W\[X擾
//
//  RETURN
//    o[WiCStringNXj
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
CString CSVIsamDlg::GetProductVersion()
{
	DWORD dwLen;
	DWORD dwHandle;
	CString productVersion = "";

	// o[W񃊃\[X̃TCY擾
	_TCHAR szPath[256+1];
	GetModuleFileName(NULL, szPath, sizeof(szPath));
	_TCHAR szFile[256+1], szExt[256+1];
	_tsplitpath_s(szPath, NULL, 0, NULL, 0, szFile, 257, szExt, 257);
	char pcExe[256+1];
	sprintf_s(pcExe, 257, "%s%s", szFile, szExt);
	dwLen = ::GetFileVersionInfoSize(pcExe, &dwHandle);
	if(dwLen)
	{
		// obt@̊m
		char *lpData = new char[dwLen + 1];
		if(lpData)
		{
			// o[W񃊃\[Xobt@ɓǂݍ
			if(::GetFileVersionInfo(pcExe, 0, dwLen, lpData))
			{
				UINT nLen;
				DWORD *dwLang;
				char lpSubBlock[50] = _T("\\VarFileInfo\\Translation");

				// lang-codepage擾
				if(::VerQueryValue(lpData, lpSubBlock, (void **)&dwLang, &nLen))
				{
					// lang-codepagetH[}bg
					char lpLang[9];
					sprintf_s(lpLang, 9, "%04x%04x", LOWORD(*dwLang), HIWORD(*dwLang));

					// 擾
					LPTSTR lpBuffer;
					LPTSTR lpString = _T("ProductVersion");  // io[W
					sprintf_s(lpSubBlock, 50, "\\StringFileInfo\\%s\\%s", lpLang, lpString);
					::VerQueryValue(lpData, lpSubBlock, (void **)&lpBuffer, &nLen);

					//擾
					productVersion = lpBuffer;
				}
			}
			delete [] lpData;
		}
	}
	return productVersion;
}

// obt@I2CR}hZbg擾
int CSVIsamDlg::GetI2cCmdForString(char *pcStr, int len, unsigned char *pucCmd, int *bytelen)
{
	int j,e,val;
	char *pcPtr,*pcbPtr;

	pcbPtr = pcStr;

	// ̒擾
	j = (int)strnlen(pcStr,256);

	// Rgss̓XLbvƂ
	if(*pcStr == '#' || *pcStr == ';' || j < 3) return -1;

	// EFCgsmF
	if(strstr(pcbPtr, "wt") || strstr(pcbPtr, "wait")){
		// ̃J}̈ʒuT
		pcPtr = strchr( pcbPtr, ',' );
		// waitl擾
		sscanf_s(pcPtr+1,"%d",bytelen);
		return 1;
	}

	// I2CR}hoJn
	j = e = 0;
	while(1){

		// ̃J}̈ʒuT
		pcPtr = strchr( pcbPtr, ',' );
		if(pcPtr != NULL){
			*pcPtr = '\0';
		}else{
			e = 1;
		}

		// l擾
		sscanf_s(pcbPtr,"%x",&val);
		if(val > 0xff){
			*(pucCmd+j) = (unsigned char)((val >> 8) & 0xff);
			j++;
		}
		*(pucCmd+j) = (unsigned char)((val >> 0) & 0xff);
		j++;

		if(e) break;
		else pcbPtr = pcPtr + 1;
	}

	*bytelen = j;
	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ParamWrite
//
//  PARAMETER
//
//  SUMMARY
//    Write parameter file
//
//  EXPLANATION
//    p[^t@C͂āAI2C gď
//
//  RETURN
//    BOOL TRUE:No error FALSE:error
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIsamDlg::ParamWrite(LPCTSTR lpstrFileName)
{
	char	strReadLine[256];
	BOOL	bOpen = FALSE;
	FILE*	fp;
	DWORD	ret = 0;
	CSviControl1 *pControl;
	unsigned char ucCmd[10];
	int bytelen;

#if 1
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}
#endif

	fopen_s( &fp, lpstrFileName, "r" );
	if( !fp ) return FALSE;

	// foCXI[v
#if 1
	if( !pControl->IsOpen() )
	{
		pControl->SetBoardNo(m_selid+1);
		ret = pControl->SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			fclose( fp );
			return FALSE;
		}
		bOpen = TRUE;
	}
#endif

	while( fgets( strReadLine, 256, fp ) ) {

		// Sďɕϊ
		_strlwr_s( strReadLine, 256 );

		switch(GetI2cCmdForString(strReadLine, 256, ucCmd, &bytelen))
		{
		case -1:
			continue; // skip
		case 1:
			Sleep(bytelen); // wait
			break;
		case 0:	// send I2C Command
#if 1
			ret = pControl->WriteBlock(0,(DWORD)ucCmd[0],bytelen-2,&ucCmd[1]);
			if( ret != SVIUSB20_RET_NORMAL ){
				CString cStr;
				cStr.Format("No.%d I2C Write Wrror ret=%x(%s)",m_selid+1,ret,strReadLine);
				AfxMessageBox(cStr);
				goto err_1;
			}
#endif
			break;
		}
	}

err_1:

	// foCX̃N[Y
	if( bOpen )
		pControl->SviClose();
	fclose( fp );

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DSPBlockWrite
//
//  PARAMETER
//    dwSlave dwSubAddress dwWriteMode dwSendCnt pucSendBuf
//
//  SUMMARY
//    DSP Block write
//
//  EXPLANATION
//    DSP ɑ΂ I2C Œl
//
//  RETURN
//    G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIsamDlg::DSPBlockWrite( DWORD dwSlave, DWORD dwSubAddress, DWORD dwWriteMode, DWORD dwSendCnt, PUCHAR pucSendBuf )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	int		ret;
	LPBYTE	lpWriteBuff;
	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	dwSlave &= 0x000000FF;

	// MTCY + R}hm
	lpWriteBuff	= (LPBYTE)malloc( dwSendCnt + 1 );
	if( !lpWriteBuff ) return FALSE;
	lpWriteBuff[0]	= (BYTE)(dwSubAddress & 0x000000FF);
	for( int i = 1 ; i <= (int)dwSendCnt ; i++ )
		lpWriteBuff[i] = (BYTE)pucSendBuf[i-1];
	ret = pControl->WriteBlock( dwWriteMode, dwSlave, dwSendCnt, lpWriteBuff );

	TRACE( "DSPBlockWrite cmd [0x%02X ret[0x%08X\n", dwSlave, ret );

	free( lpWriteBuff );
	return ret;
}	// MPU_BlkWrite End

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DSPBlockRead
//
//  PARAMETER
//
//  SUMMARY
//    Read DSP Data by block mode
//
//  EXPLANATION
//    I2C buffer write p̃f[^쐬
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIsamDlg::DSPBlockRead( DWORD dwSlave, DWORD dwSubAddress, DWORD dwReadMode, DWORD dwRcvCnt, PUCHAR pucRcvBuf )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	int		ret;
	LPBYTE	lpReadBuff;

	dwSlave &= 0x000000FF;

	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	// MTCY + R}hm
	lpReadBuff	= (LPBYTE)malloc( dwRcvCnt + 1 );
	if( !lpReadBuff ) return FALSE;
	lpReadBuff[0]	= (BYTE)( dwSubAddress & 0x000000FF );
	ret = pControl->ReadBlock( dwReadMode, dwSlave, dwRcvCnt, lpReadBuff );
	for( int i = 1 ; i <= (int)dwRcvCnt ; i++ )
		pucRcvBuf[i-1] = lpReadBuff[i];

	TRACE( "DSPBlockRead  cmd [0x%02X ret[0x%08X\n", dwSlave, ret );

	free( lpReadBuff );
	return ret;
}	// MPU_BlkRead End

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DSPBlockWrite
//
//  PARAMETER
//    dwSlave dwSubAddress dwWriteMode dwSendCnt pucSendBuf
//
//  SUMMARY
//    DSP Block write
//
//  EXPLANATION
//    DSP ɑ΂ I2C Œl
//
//  RETURN
//    G[R[h
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIsamDlg::DSPBlockWrite2( int id, DWORD dwSlave, DWORD dwSubAddress, DWORD dwWriteMode, DWORD dwSendCnt, PUCHAR pucSendBuf )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	int		ret;
	LPBYTE	lpWriteBuff;
	CSviControl1 *pControl;
	switch(id){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	dwSlave &= 0x000000FF;

	// MTCY + R}hm
	lpWriteBuff	= (LPBYTE)malloc( dwSendCnt + 1 );
	if( !lpWriteBuff ) return FALSE;
	lpWriteBuff[0]	= (BYTE)(dwSubAddress & 0x000000FF);
	for( int i = 1 ; i <= (int)dwSendCnt ; i++ )
		lpWriteBuff[i] = (BYTE)pucSendBuf[i-1];
	ret = pControl->WriteBlock( dwWriteMode, dwSlave, dwSendCnt, lpWriteBuff );

	TRACE( "DSPBlockWrite cmd [0x%02X ret[0x%08X\n", dwSlave, ret );

	free( lpWriteBuff );
	return ret;
}	// MPU_BlkWrite End

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DSPBlockRead
//
//  PARAMETER
//
//  SUMMARY
//    Read DSP Data by block mode
//
//  EXPLANATION
//    I2C buffer write p̃f[^쐬
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIsamDlg::DSPBlockRead2( int id,  DWORD dwSlave, DWORD dwSubAddress, DWORD dwReadMode, DWORD dwRcvCnt, PUCHAR pucRcvBuf )
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	int		ret;
	LPBYTE	lpReadBuff;

	dwSlave &= 0x000000FF;

	CSviControl1 *pControl;
	switch(id){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	// MTCY + R}hm
	lpReadBuff	= (LPBYTE)malloc( dwRcvCnt + 1 );
	if( !lpReadBuff ) return FALSE;
	lpReadBuff[0]	= (BYTE)( dwSubAddress & 0x000000FF );
	ret = pControl->ReadBlock( dwReadMode, dwSlave, dwRcvCnt, lpReadBuff );
	for( int i = 1 ; i <= (int)dwRcvCnt ; i++ )
		pucRcvBuf[i-1] = lpReadBuff[i];

	TRACE( "DSPBlockRead  cmd [0x%02X ret[0x%08X\n", dwSlave, ret );

	free( lpReadBuff );
	return ret;
}	// MPU_BlkRead End

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SkipSpace
//
//  PARAMETER
//    char *
//
//  SUMMARY
//    Skip Space and some delimiter
//
//  EXPLANATION
//    ̕΂
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIsamDlg::SkipSpace( char *pszDest)
{
	int pos = 0;

	while( (*(pszDest + pos) == '\t' ) || (*(pszDest + pos) == ' ' ) || (*(pszDest + pos) == ',' ) )
		pos++;
	return pos;
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnButtonSend
//
//  PARAMETER
//    void
//
//  SUMMARY
//    Send {^Ƃ̏
//
//  EXPLANATION
//    Send {^Ƃ̏
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnButtonSend()
{
	// GfBbgRg[t@C擾ăp[^𓊂
	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;
	CEdit *pEdit = (CEdit *)GetDlgItem( IDC_EDIT7 );
	CString strPathName;

	pEdit->GetWindowText( strPathName );
	if( strPathName.GetLength() != 0)
		ParamWrite( strPathName );

}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnButtonRead
//
//  PARAMETER
//    void
//
//  SUMMARY
//    Read {^Ƃ̏
//
//  EXPLANATION
//    Read {^Ƃ̏
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnButtonRead()
{
	int		ret;
	DWORD	dwSlave = 0, dwSubAddress = 0;
	BYTE	byData = 0;
	BOOL	bOpen = FALSE;
	CString	strSlave;
	CString	strSubAddress;
	CString	strValue;
	CEdit	*pEditSlave = (CEdit *)GetDlgItem( IDC_EDIT8 );
	CEdit	*pEditSub   = (CEdit *)GetDlgItem( IDC_EDIT9 );
	CEdit	*pEditValue = (CEdit *)GetDlgItem( IDC_EDIT10 );

	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;
	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	// foCXI[v
	if( !pControl->IsOpen() )
	{
		pControl->SetBoardNo(m_selid+1);
		ret = pControl->SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return;
		}
		bOpen = TRUE;
	}

	// GfBbg{bNX X[uAhXATuAhX擾
	pEditSlave->GetWindowText( strSlave );
	pEditSub->GetWindowText  ( strSubAddress );

	if( CheckHex( (int*)&dwSlave, strSlave ) != TRUE )
	{
		AfxMessageBox("Do not get slave address.");
		goto settlement;
	}
	if( CheckHex( (int*)&dwSubAddress, strSubAddress ) != TRUE )
	{
		AfxMessageBox("Do not get sub address.");
		goto settlement;
	}

	// I2C Read
	if( DSPBlockRead( dwSlave, dwSubAddress, 0, 1, &byData ) != SVIUSB20_RET_NORMAL )
	{
		AfxMessageBox("Do not read I2C.");
		goto settlement;
	}

	// GfBbg{bNXɒl\
	strValue.Format( "%02X", (int)byData );
	pEditValue->SetWindowText( strValue );

settlement:
	// foCXN[Y
	if( bOpen )
		pControl->SviClose();

}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnButtonWrite
//
//  PARAMETER
//    void
//
//  SUMMARY
//    Write {^Ƃ̏
//
//  EXPLANATION
//    Write {^Ƃ̏
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnButtonWrite()
{
	int		ret;
	DWORD	dwSlave = 0, dwSubAddress = 0, dwValue = 0;
	BYTE	byData = 0;
	BOOL	bOpen = FALSE;
	CString	strSlave;
	CString	strSubAddress;
	CString	strValue;
	CEdit	*pEditSlave = (CEdit *)GetDlgItem( IDC_EDIT8 );
	CEdit	*pEditSub   = (CEdit *)GetDlgItem( IDC_EDIT9 );
	CEdit	*pEditValue = (CEdit *)GetDlgItem( IDC_EDIT10 );

	m_selid = GetCheckedRadioButton(IDC_BSEL_1, IDC_BSEL_4) - IDC_BSEL_1;
	CSviControl1 *pControl;
	switch(m_selid){
	case 0: pControl = &gggSviControl1; break;
	case 1: pControl = (CSviControl1 *)&gggSviControl2; break;
	case 2: pControl = (CSviControl1 *)&gggSviControl3; break;
	case 3: pControl = (CSviControl1 *)&gggSviControl4; break;
	}

	// foCXI[v
	if( !pControl->IsOpen() )
	{
		pControl->SetBoardNo(m_selid+1);
		ret = pControl->SviOpen();
		if(ret != SVIUSB20_RET_NORMAL) {
			AfxMessageBox(IDS_ERR_SVI_OPEN);
			TRACE("SviOpen ret[%08X]\n");
			return;
		}
		bOpen = TRUE;
	}

	// GfBbg{bNX X[uAhXATuAhXAޒl擾
	pEditSlave->GetWindowText( strSlave );
	pEditSub->GetWindowText  ( strSubAddress );
	pEditValue->GetWindowText( strValue );

	if( CheckHex( (int*)&dwSlave, strSlave ) != TRUE )
	{
		AfxMessageBox("Do not get slave address.");
		goto settlement;
	}
	if( CheckHex( (int*)&dwSubAddress, strSubAddress ) != TRUE )
	{
		AfxMessageBox("Do not get sub address.");
		goto settlement;
	}
	if( CheckHex( (int*)&dwValue, strValue ) != TRUE )
	{
		AfxMessageBox("Do not get write value.");
		goto settlement;
	}
	byData = (BYTE)dwValue & 0x000000FF;

	// I2C Write
	if( DSPBlockWrite( dwSlave, dwSubAddress, 0, 1, &byData ) != SVIUSB20_RET_NORMAL )
	{
		AfxMessageBox("Do not write I2C.");
		goto settlement;
	}

	// ݊
	//AfxMessageBox("Writing I2C done.");

settlement:
	// foCXN[Y
	if( bOpen )
		pControl->SviClose();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnButton8
//
//  PARAMETER
//    void
//
//  SUMMARY
//    {^8Ƃ̏
//
//  EXPLANATION
//    {^8Ƃ̏
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnButton8()
{
	// Button8̖̂擾
	char btn_name[32];
	((CButton*)GetDlgItem(IDC_BUTTON8))->GetWindowText(btn_name, 32);

	// 2l\̊Jn/~
	if(m_bBinarizationFlag == FALSE) {
		// {^̕\ԕύX
		((CButton*)GetDlgItem(IDC_BUTTON8))->SetCheck(TRUE);
		// 2l\̊Jn
		m_bBinarizationFlag = TRUE;
	}
	else {
		// {^̕\ԕύX
		((CButton*)GetDlgItem(IDC_BUTTON8))->SetCheck(FALSE);
		// 2l\̒~
		m_bBinarizationFlag = FALSE;
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnButton9
//
//  PARAMETER
//    void
//
//  SUMMARY
//    {^9Ƃ̏
//
//  EXPLANATION
//    {^9Ƃ̏
//
//  RETURN
//    void
//
//  REMARKS
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnButton9()
{
	// Button9̖̂擾
	char btn_name[32];
	((CButton*)GetDlgItem(IDC_BUTTON9))->GetWindowText(btn_name, 32);

	// YVF[fBO␳̊Jn/~
	if(m_bLensShadingFlag == FALSE) {
		// {^̕\ԕύX
		((CButton*)GetDlgItem(IDC_BUTTON9))->SetCheck(TRUE);
		// YVF[fBO␳̊Jn
		m_bLensShadingFlag = TRUE;
	}
	else {
		// {^̕\ԕύX
		((CButton*)GetDlgItem(IDC_BUTTON9))->SetCheck(FALSE);
		// YVF[fBO␳̒~
		m_bLensShadingFlag = FALSE;
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniMonMode
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O[h擾
//
//  EXPLANATION
//    INIt@C j^O[h擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniMonMode()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// j^O[h擾
	m_MonMode = IniCntl.ReadInt(DEF_INI_KEY_MONMODE, DEF_INIT_MONMODE);
	// j^O^CAEg擾
	m_MonTimeout = IniCntl.ReadInt(DEF_INI_KEY_MONTIMEOUT, DEF_INIT_MONTIMEOUT);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    WriteIniMonMode
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//     j^O[hۑ
//
//  EXPLANATION
//    INIt@C j^O[hۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::WriteIniMonMode()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// j^O[hۑ
	IniCntl.WriteInt(DEF_INI_KEY_MONMODE, m_MonMode);

	// j^O^CAEgۑ
	IniCntl.WriteInt(DEF_INI_KEY_MONTIMEOUT, m_MonTimeout);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniMultipleTransfer
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    C[WZTݒ̐ݒl擾
//
//  EXPLANATION
//    INIt@C C[WZTݒ̐ݒl擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniMultipleTransfer()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// j^O[h擾
	m_MonMode = IniCntl.ReadInt(DEF_INI_KEY_MONMODE, DEF_INIT_MONMODE);
	// j^O^CAEg擾
	m_MonTimeout = IniCntl.ReadInt(DEF_INI_KEY_MONTIMEOUT, DEF_INIT_MONTIMEOUT);

	// t@CpX擾
	m_MultiFilePath1 = IniCntl.ReadString(DEF_INI_KEY_MULTITRANS_FILEPATH1, "");
	m_MultiFilePath2 = IniCntl.ReadString(DEF_INI_KEY_MULTITRANS_FILEPATH2, "");
	m_MultiFilePath3 = IniCntl.ReadString(DEF_INI_KEY_MULTITRANS_FILEPATH3, "");
	m_MultiFilePath4 = IniCntl.ReadString(DEF_INI_KEY_MULTITRANS_FILEPATH4, "");
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    WriteIniMultipleTransfer
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//     C[WZTݒ̐ݒlۑ
//
//  EXPLANATION
//    INIt@C C[WZTݒ̐ݒlۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::WriteIniMultipleTransfer()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// t@CpXۑ
	IniCntl.WriteString(DEF_INI_KEY_MULTITRANS_FILEPATH1, m_MultiFilePath1);
	IniCntl.WriteString(DEF_INI_KEY_MULTITRANS_FILEPATH2, m_MultiFilePath2);
	IniCntl.WriteString(DEF_INI_KEY_MULTITRANS_FILEPATH3, m_MultiFilePath3);
	IniCntl.WriteString(DEF_INI_KEY_MULTITRANS_FILEPATH4, m_MultiFilePath4);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniLensShading
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    YVF[fBO␳p[^擾
//
//  EXPLANATION
//    INIt@C YVF[fBO␳p[^擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniLensShading()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// Xebv擾
	m_iLensShading_Step = IniCntl.ReadInt(DEF_INI_KEY_LENSSTEP, DEF_INIT_LENSSTEP);
	// l擾
	m_iLensShading_Thres = IniCntl.ReadInt(DEF_INI_KEY_LENSTH, DEF_INIT_LENSTH);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ReadIniBinarization
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    2l\p[^擾
//
//  EXPLANATION
//    INIt@C 2l\p[^擾
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::ReadIniBinarization()
{
	CIniControl IniCntl(DEF_INI_APP, ggszIniFile);	// INIRg[

	// l擾
	m_iBinarization_Thres = IniCntl.ReadInt(DEF_INI_KEY_BINTH, DEF_INIT_BINTH);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedButton5
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ̃ZT[ݒt@Cݒ肷_CAOĂяo܂B
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedButton5()
{
	SVItrnsfersetDlg dlg;

	// t@CpXݒ
	dlg.SetFilePath1(m_MultiFilePath1);
	dlg.SetFilePath2(m_MultiFilePath2);
	dlg.SetFilePath3(m_MultiFilePath3);
	dlg.SetFilePath4(m_MultiFilePath4);

	// Setting_CAO\
	if(dlg.DoModal() == IDOK) 
	{
		// t@CpX擾
		m_MultiFilePath1 = dlg.GetFilePath1();
		m_MultiFilePath2 = dlg.GetFilePath2();
		m_MultiFilePath3 = dlg.GetFilePath3();
		m_MultiFilePath4 = dlg.GetFilePath4();
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedButton6
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    ̃ZT[Ɏw肵ݒt@C𑗂܂B
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedButton6()
{
	int selID = m_selid;			// m_selid֐ňꎞύX̂ŏlۑ

	// 1Ԃɐݒ肵ݒt@C擾ăp[^𓊂
	if(((CButton*)GetDlgItem(IDC_SET_1))->IsWindowEnabled() == TRUE)
	{
		if( m_MultiFilePath1.GetLength() != 0)
		{
			// IDԍύX܂
			m_selid = 0;
			// p[^܂
			ParamWrite( m_MultiFilePath1 );
		}
	}
	// 2Ԃɐݒ肵ݒt@C擾ăp[^𓊂
	if(((CButton*)GetDlgItem(IDC_SET_2))->IsWindowEnabled() == TRUE)
	{
		if( m_MultiFilePath2.GetLength() != 0)
		{
			// IDԍύX܂
			m_selid = 1;
			// p[^܂
			ParamWrite( m_MultiFilePath2 );
		}
	}
	// 3Ԃɐݒ肵ݒt@C擾ăp[^𓊂
	if(((CButton*)GetDlgItem(IDC_SET_3))->IsWindowEnabled() == TRUE)
	{
		if( m_MultiFilePath3.GetLength() != 0)
		{
			// IDԍύX܂
			m_selid = 2;
			// p[^܂
			ParamWrite( m_MultiFilePath3 );
		}
	}
	// 4Ԃɐݒ肵ݒt@C擾ăp[^𓊂
	if(((CButton*)GetDlgItem(IDC_SET_4))->IsWindowEnabled() == TRUE){
		if( m_MultiFilePath4.GetLength() != 0)
		{
			// IDԍύX܂
			m_selid = 3;
			// p[^܂
			ParamWrite( m_MultiFilePath4 );
		}
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedSet1
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    MainViewɂPԂ̃J̉摜\܂
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedSet1()
{
	SingleMonitorViewChange(IDC_BSEL_1);

}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedSet2
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    MainView2Ԃ̃J̉摜\܂
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedSet2()
{
	SingleMonitorViewChange(IDC_BSEL_2);
}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedSet3
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    MainView3Ԃ̃J̉摜\܂
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedSet3()
{
	SingleMonitorViewChange(IDC_BSEL_3);
}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnBnClickedSet4
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    MainView4Ԃ̃J̉摜\܂
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::OnBnClickedSet4()
{
	SingleMonitorViewChange(IDC_BSEL_4);
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    ViewChange
//
//  PARAMETER
//    int nID : }`j^[r[̃Rg[ID
//
//  SUMMARY
//    VOj^[r[Ƀp[^Ŏw肵ID̉摜\܂
//
//  EXPLANATION
//    
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIsamDlg::SingleMonitorViewChange(int nID)
{
	// ID̑Ó
	if(nID == IDC_BSEL_1 || nID == IDC_BSEL_2 || nID == IDC_BSEL_3 || nID == IDC_BSEL_4 )
	{
		// ID}`j^[IDȂ̂ŏp܂B
		OnMs1();

		// BoardSelectPԂɕύX܂B
		switch(nID){
		case IDC_BSEL_1:
			m_selid = 0;
			((CButton*)GetDlgItem(IDC_BSEL_1))->SetCheck(TRUE);
			((CButton*)GetDlgItem(IDC_BSEL_2))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_3))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_4))->SetCheck(FALSE);
			break;
		case IDC_BSEL_2:
			m_selid = 1;
			((CButton*)GetDlgItem(IDC_BSEL_1))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_2))->SetCheck(TRUE);
			((CButton*)GetDlgItem(IDC_BSEL_3))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_4))->SetCheck(FALSE);
			break;
		case IDC_BSEL_3:
			m_selid = 2;
			((CButton*)GetDlgItem(IDC_BSEL_1))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_2))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_3))->SetCheck(TRUE);
			((CButton*)GetDlgItem(IDC_BSEL_4))->SetCheck(FALSE);
			break;
		case IDC_BSEL_4:
			m_selid = 3;
			((CButton*)GetDlgItem(IDC_BSEL_1))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_2))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_3))->SetCheck(FALSE);
			((CButton*)GetDlgItem(IDC_BSEL_4))->SetCheck(TRUE);
			break;
		}
		// j^OJn܂B
		OnMs1();
	}
	return;
}
