/*FILE------------------------------------------------------------------------*/
//
//  DoubleBuffer.h
//
//  SUMMARY
//    Monitoring Double Buffer
//
//  WRITER
//    Ryuta Kimura
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/
#ifndef _DOUBLE_BUFFER_H
#define _DOUBLE_BUFFER_H

#include "Comm.h"
#include "FrameData.h"

/*CLASS-----------------------------------------------------------------------*/
//  NAME
//    CDoubleBuffer
//
//  SUMMARY
//    j^O_uobt@NX
//
//  EXPLANATION
//    j^O_uobt@@\NX
//    
//  REMARKS
//    NONE
//
/*CLASS-----------------------------------------------------------------------*/
class CDoubleBuffer 
{
public:
	// RXgN^
	CDoubleBuffer();

	// fXgN^
	virtual ~CDoubleBuffer();

public:
	void Release();

	CFrameData* GetWriteFrame();

	CFrameData* GetReadFrame();

private:
	int m_nView;	// \Ώۃobt@NO
	CFrameData* m_pDoubleFrame;	// _uobt@t[
};

#endif // _DOUBLE_BUFFER_H End