/*FILE------------------------------------------------------------------------*/
//
//  SVIcmdsetDlg.cpp
//
//  SUMMARY
//    Monitoring & Recording Setting
//
//  WRITER
//    NetVsion
//
//  HISTORY
//    2005/05/30 New creation
//
/*FILE------------------------------------------------------------------------*/

#include "stdafx.h"
#include "SVIsam.h"
#include "SVIcmdsetDlg.h"
#include "SVISamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVIcmdsetDlg _CAO


CSVIcmdsetDlg::CSVIcmdsetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVIcmdsetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSVIcmdsetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CSVIcmdsetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVIcmdsetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSVIcmdsetDlg, CDialog)
	//{{AFX_MSG_MAP(CSVIcmdsetDlg)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CSVIcmdsetDlg::OnOK)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIcmdsetDlg bZ[W nh

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetMonCut
//
//  PARAMETER
//    MONITORING_CUTOUT_SETTING MonCutSet : j^O؂o
//
//  SUMMARY
//    j^O؂o̐ݒ
//
//  EXPLANATION
//    j^O؂oOݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    _CAO\Oɐݒ肵܂
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::SetMonCut(MONITORING_CUTOUT_SETTING MonCutSet)
{
	m_MonCutSet = MonCutSet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetMonCut
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O؂o̎擾
//
//  EXPLANATION
//    j^O؂oO擾܂
//
//  RETURN
//    Vj^O؂o
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
MONITORING_CUTOUT_SETTING CSVIcmdsetDlg::GetMonCut()
{
	return m_MonCutSet;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetPicType
//
//  PARAMETER
//    int nPicType : PictureTyep
//
//  SUMMARY
//    PictureTyep̐ݒ
//
//  EXPLANATION
//   PictureTyepOݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    _CAO\Oɐݒ肵܂
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::SetPicType(int nPicType_1,int nPicType_2,int nPicType_3,int nPicType_4)
{
	m_PicType_1 = nPicType_1;
	m_PicType_2 = nPicType_2;
	m_PicType_3 = nPicType_3;
	m_PicType_4 = nPicType_4;
}

// Input VSync Invertݒ
void CSVIcmdsetDlg::SetInputVSyncInvert(int nVSNeg_1,int nVSNeg_2,int nVSNeg_3,int nVSNeg_4)
{
	m_VSNeg_1 = nVSNeg_1;
	m_VSNeg_2 = nVSNeg_2;
	m_VSNeg_3 = nVSNeg_3;
	m_VSNeg_4 = nVSNeg_4;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetPicType
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    PictureTyep̎擾
//
//  EXPLANATION
//    PictureTyepO擾܂
//
//  RETURN
//    VPictureTyep
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::GetPicType(int *nPicType_1,int *nPicType_2,int *nPicType_3,int *nPicType_4)
{
	*nPicType_1 = m_PicType_1;
	*nPicType_2 = m_PicType_2;
	*nPicType_3 = m_PicType_3;
	*nPicType_4 = m_PicType_4;
}

// Input VSync Invert擾
void CSVIcmdsetDlg::GetInputVSyncInvert(int *nVSNeg_1,int *nVSNeg_2,int *nVSNeg_3,int *nVSNeg_4)
{
	*nVSNeg_1 = m_VSNeg_1;
	*nVSNeg_2 = m_VSNeg_2;
	*nVSNeg_3 = m_VSNeg_3;
	*nVSNeg_4 = m_VSNeg_4;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnInitDialog
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    _CAO\
//
//  EXPLANATION
//    _CAO\ۂɏs܂
//
//  RETURN
//    ̓tH[JX̐ݒ
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIcmdsetDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// PictureTypeݒ
	SetPictureTypeSetting();

	// j^O[hݒ
	SetMonitoringModeSetting();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnOK
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    [Set]{^
//
//  EXPLANATION
//    Rg[֓͂Ă`FbNAG[Ȃ΃_CAO܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::OnOK()
{
	// PictureType擾
	GetPictureTypeSetting();

	// j^O[h擾
	GetMonitoringModeSetting();

	// Lv`[[hݒ
	WriteCaptureMode();

	CDialog::OnOK();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetPictureTypeSetting
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    PictureTypeݒ
//
//  EXPLANATION
//    Rg[PictureTypeݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::SetPictureTypeSetting()
{
	// Board_1 Picture TypeIvVݒ
	switch (m_PicType_1)
	{
		case UYVY:
			// UYVYɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY_1))->SetCheck(TRUE);
			break;
		case UYVY16:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY16_1))->SetCheck(TRUE);
			break;
		case YUY2:
			// YUY2ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY2_1))->SetCheck(TRUE);
			break;
		case YUY216:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY216_1))->SetCheck(TRUE);
			break;
		default:
			// UYVYɂ`FbN
			m_PicType_1 = UYVY;
			((CButton*)GetDlgItem(IDC_UYVY_1))->SetCheck(TRUE);
			break;
	}
	if(m_VSNeg_1) ((CButton*)GetDlgItem(IDC_CHK_VSNEG_1))->SetCheck(TRUE);

	// Board_2 Picture TypeIvVݒ
	switch (m_PicType_2)
	{
		case UYVY:
			// UYVYɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY_2))->SetCheck(TRUE);
			break;
		case UYVY16:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY16_2))->SetCheck(TRUE);
			break;
		case YUY2:
			// YUY2ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY2_2))->SetCheck(TRUE);
			break;
		case YUY216:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY216_2))->SetCheck(TRUE);
			break;
		default:
			// UYVYɂ`FbN
			m_PicType_2 = UYVY;
			((CButton*)GetDlgItem(IDC_UYVY_2))->SetCheck(TRUE);
			break;
	}
	if(m_VSNeg_2) ((CButton*)GetDlgItem(IDC_CHK_VSNEG_2))->SetCheck(TRUE);

	// Board_3 Picture TypeIvVݒ
	switch (m_PicType_3)
	{
		case UYVY:
			// UYVYɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY_3))->SetCheck(TRUE);
			break;
		case UYVY16:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY16_3))->SetCheck(TRUE);
			break;
		case YUY2:
			// YUY2ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY2_3))->SetCheck(TRUE);
			break;
		case YUY216:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY216_3))->SetCheck(TRUE);
			break;
		default:
			// UYVYɂ`FbN
			m_PicType_3 = UYVY;
			((CButton*)GetDlgItem(IDC_UYVY_3))->SetCheck(TRUE);
			break;
	}
	if(m_VSNeg_3) ((CButton*)GetDlgItem(IDC_CHK_VSNEG_3))->SetCheck(TRUE);

	// Board_4 Picture TypeIvVݒ
	switch (m_PicType_1)
	{
		case UYVY:
			// UYVYɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY_4))->SetCheck(TRUE);
			break;
		case UYVY16:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_UYVY16_4))->SetCheck(TRUE);
			break;
		case YUY2:
			// YUY2ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY2_4))->SetCheck(TRUE);
			break;
		case YUY216:
			// UYVY-16ɂ`FbN
			((CButton*)GetDlgItem(IDC_YUY216_4))->SetCheck(TRUE);
			break;
		default:
			// UYVYɂ`FbN
			m_PicType_4 = UYVY;
			((CButton*)GetDlgItem(IDC_UYVY_4))->SetCheck(TRUE);
			break;
	}
	if(m_VSNeg_4) ((CButton*)GetDlgItem(IDC_CHK_VSNEG_4))->SetCheck(TRUE);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetPictureTypeSetting
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    PictureType擾
//
//  EXPLANATION
//    Rg[PictureType擾܂
//
//  RETURN
//    ̓G[`FbN
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIcmdsetDlg::GetPictureTypeSetting()
{
	// Picture TypeݒőIẴIvV{^hcl擾

	if(((CButton*)GetDlgItem(IDC_UYVY_1))->GetCheck()) m_PicType_1 = UYVY;
	else if(((CButton*)GetDlgItem(IDC_YUY2_1))->GetCheck()) m_PicType_1 = YUY2;
	else if(((CButton*)GetDlgItem(IDC_YUY216_1))->GetCheck()) m_PicType_1 = YUY216;
	else m_PicType_1 = UYVY16;
	m_VSNeg_1 = ((CButton*)GetDlgItem(IDC_CHK_VSNEG_1))->GetCheck();

	if(((CButton*)GetDlgItem(IDC_UYVY_2))->GetCheck()) m_PicType_2 = UYVY;
	else if(((CButton*)GetDlgItem(IDC_YUY2_2))->GetCheck()) m_PicType_2 = YUY2;
	else if(((CButton*)GetDlgItem(IDC_YUY216_2))->GetCheck()) m_PicType_2 = YUY216;
	else m_PicType_2 = UYVY16;
	m_VSNeg_2 = ((CButton*)GetDlgItem(IDC_CHK_VSNEG_2))->GetCheck();

	if(((CButton*)GetDlgItem(IDC_UYVY_3))->GetCheck()) m_PicType_3 = UYVY;
	else if(((CButton*)GetDlgItem(IDC_YUY2_3))->GetCheck()) m_PicType_3 = YUY2;
	else if(((CButton*)GetDlgItem(IDC_YUY216_3))->GetCheck()) m_PicType_3 = YUY216;
	else m_PicType_3 = UYVY16;
	m_VSNeg_3 = ((CButton*)GetDlgItem(IDC_CHK_VSNEG_3))->GetCheck();

	if(((CButton*)GetDlgItem(IDC_UYVY_4))->GetCheck()) m_PicType_4 = UYVY;
	else if(((CButton*)GetDlgItem(IDC_YUY2_4))->GetCheck()) m_PicType_4 = YUY2;
	else if(((CButton*)GetDlgItem(IDC_YUY216_4))->GetCheck()) m_PicType_4 = YUY216;
	else m_PicType_4 = UYVY16;
	m_VSNeg_4 = ((CButton*)GetDlgItem(IDC_CHK_VSNEG_4))->GetCheck();

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    WriteCaptureMode
//
//  PARAMETER
//    none
//
//  SUMMARY
//    SVI{[hWX^ɃLv`[[hݒ
//
//  EXPLANATION
//    SVI{[hWX^ɃLv`[[hݒ
//
//  RETURN
//    ̓G[`FbN
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIcmdsetDlg::WriteCaptureMode()
{
	int		ret;
	BYTE	byData[10];
	int		picmode;	// 摜ʒm	bit0-1:F(1or2or3), bit2:1F̃rbg(0:8bit,1:16bit)

	// Board_1 foCXI[v
	if(gggSviControl1.isExist()) {
		gggSviControl1.SetBoardNo(1);
		if( !gggSviControl1.IsOpen() ) {
			ret = gggSviControl1.SviOpen();
			if(ret != SVIUSB20_RET_NORMAL) {
				AfxMessageBox(IDS_ERR_SVI_OPEN);
				TRACE("SviOpen ret[%08X]\n");
				return FALSE;
			}
		}
		// ݂̐ݒl擾
		byData[0] = 0;
		if(gggSviControl1.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// sN`[[h8,16𔻒f
		if (m_PicType_1 == UYVY || m_PicType_1 == YUY2) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(8bit[h)
			picmode = 0x2;
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(16bit[h)
			picmode = 0x6;
		}
		// Lv`[[hύX
		byData[0] = 0;
		if( gggSviControl1.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// ݂Input VSync Invertݒl擾
		byData[0] = 0x38;
		if(gggSviControl1.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// Input VSync Invertݒ
		if (m_VSNeg_1 == 0) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(Normal VS Invert[h)
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(Neg VS Invert[h)
		}
		// Input VSync InvertύX
		byData[0] = 0x38;
		if( gggSviControl1.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// j^O[hύX
		if( !gggSviControl1.SetStatus((SVIUSB20_SETPARAM_BIT0|SVIUSB20_SETPARAM_BIT6),0,0,0,m_MonMode,picmode) ) {
			AfxMessageBox("Do not set SetStatus.");
			return FALSE;
		}
	}

	// Board_2 foCXI[v
	if(gggSviControl2.isExist()) {
		gggSviControl2.SetBoardNo(2);
		if( !gggSviControl2.IsOpen() ) {
			ret = gggSviControl2.SviOpen();
			if(ret != SVIUSB20_RET_NORMAL) {
				AfxMessageBox(IDS_ERR_SVI_OPEN);
				TRACE("SviOpen ret[%08X]\n");
				return FALSE;
			}
		}
		// ݂̐ݒl擾
		byData[0] = 0;
		if(gggSviControl2.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// sN`[[h8,16𔻒f
		if (m_PicType_2 == UYVY || m_PicType_2 == YUY2) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(8bit[h)
			picmode = 0x2;
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(16bit[h)
			picmode = 0x6;
		}
		// Lv`[[hύX
		byData[0] = 0;
		if( gggSviControl2.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// ݂Input VSync Invertݒl擾
		byData[0] = 0x38;
		if(gggSviControl2.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// Input VSync Invertݒ
		if (m_VSNeg_2 == 0) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(Normal VS Invert[h)
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(Neg VS Invert[h)
		}
		// Input VSync InvertύX
		byData[0] = 0x38;
		if( gggSviControl2.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// j^O[hύX
		if( !gggSviControl2.SetStatus((SVIUSB20_SETPARAM_BIT0|SVIUSB20_SETPARAM_BIT6),0,0,0,m_MonMode,picmode) ) {
			AfxMessageBox("Do not set SetStatus.");
			return FALSE;
		}
	}

	// Board_3 foCXI[v
	if(gggSviControl3.isExist()) {
		gggSviControl3.SetBoardNo(3);
		if( !gggSviControl3.IsOpen() ) {
			ret = gggSviControl3.SviOpen();
			if(ret != SVIUSB20_RET_NORMAL) {
				AfxMessageBox(IDS_ERR_SVI_OPEN);
				TRACE("SviOpen ret[%08X]\n");
				return FALSE;
			}
		}
		// ݂̐ݒl擾
		byData[0] = 0;
		if(gggSviControl3.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// sN`[[h8,16𔻒f
		if (m_PicType_3 == UYVY || m_PicType_3 == YUY2) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(8bit[h)
			picmode = 0x2;
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(16bit[h)
			picmode = 0x6;
		}
		// Lv`[[hύX
		byData[0] = 0;
		if( gggSviControl3.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// ݂Input VSync Invertݒl擾
		byData[0] = 0x38;
		if(gggSviControl3.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// Input VSync Invertݒ
		if (m_VSNeg_3 == 0) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(Normal VS Invert[h)
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(Neg VS Invert[h)
		}
		// Input VSync InvertύX
		byData[0] = 0x38;
		if( gggSviControl3.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// j^O[hύX
		if( !gggSviControl3.SetStatus((SVIUSB20_SETPARAM_BIT0|SVIUSB20_SETPARAM_BIT6),0,0,0,m_MonMode,picmode) ) {
			AfxMessageBox("Do not set SetStatus.");
			return FALSE;
		}
	}

	// Board_4 foCXI[v
	if(gggSviControl4.isExist()) {
		gggSviControl4.SetBoardNo(4);
		if( !gggSviControl4.IsOpen() ) {
			ret = gggSviControl4.SviOpen();
			if(ret != SVIUSB20_RET_NORMAL) {
				AfxMessageBox(IDS_ERR_SVI_OPEN);
				TRACE("SviOpen ret[%08X]\n");
				return FALSE;
			}
		}
		// ݂̐ݒl擾
		byData[0] = 0;
		if(gggSviControl4.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// sN`[[h8,16𔻒f
		if (m_PicType_4 == UYVY || m_PicType_4 == YUY2) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(8bit[h)
			picmode = 0x2;
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(16bit[h)
			picmode = 0x6;
		}
		// Lv`[[hύX
		byData[0] = 0;
		if( gggSviControl4.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// ݂Input VSync Invertݒl擾
		byData[0] = 0x38;
		if(gggSviControl4.ReadBlock(0,0x8,1,byData) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not read I2C.");
			return FALSE;
		}
		// Input VSync Invertݒ
		if (m_VSNeg_4 == 0) {
			byData[1] = byData[1] & 0xBF;	// 6bitڂ0ɐݒ(Normal VS Invert[h)
		}else{
			byData[1] = byData[1] | 0x40;	// 6bitڂ1ɐݒ(Neg VS Invert[h)
		}
		// Input VSync InvertύX
		byData[0] = 0x38;
		if( gggSviControl4.WriteBlock( 0, 0x8, 1, byData ) != SVIUSB20_RET_NORMAL ) {
			AfxMessageBox("Do not write I2C.");
			return FALSE;
		}
		// j^O[hύX
		if( !gggSviControl4.SetStatus((SVIUSB20_SETPARAM_BIT0|SVIUSB20_SETPARAM_BIT6),0,0,0,m_MonMode,picmode) ) {
			AfxMessageBox("Do not set SetStatus.");
			return FALSE;
		}
	}

	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetMonitoringModeSetting
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O[h擾
//
//  EXPLANATION
//    Rg[烂j^O[h擾܂
//
//  RETURN
//    ̓G[`FbN
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
BOOL CSVIcmdsetDlg::GetMonitoringModeSetting()
{
	// j^O^CAEgl擾
	if(!GetEditCtrl(IDC_MONTIMEOUT, &m_MonTimeout)) {
		m_MonTimeout = DEF_INIT_MONTIMEOUT;
		AfxMessageBox(IDS_ERR_INPUT_VALUE);
		return TRUE;
	}
	return TRUE;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetMonitoringModeSetting
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O[hݒ
//
//  EXPLANATION
//    Rg[փj^O[hݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::SetMonitoringModeSetting()
{
	// j^O^CAEglݒ
	SetEditCtrl(IDC_MONTIMEOUT, 6, m_MonTimeout);
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetMonitoringMode
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O[h̎擾
//
//  EXPLANATION
//    j^O[hO擾܂
//
//  RETURN
//    Vj^O[h
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIcmdsetDlg::GetMonitoringMode()
{
	return m_MonMode;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetMonitoringMode
//
//  PARAMETER
//    int nMonitoringMode : j^O[h
//
//  SUMMARY
//    j^O[h̐ݒ
//
//  EXPLANATION
//   j^O[hOݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    _CAO\Oɐݒ肵܂
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIcmdsetDlg::SetMonitoringMode(int nMonitoringMode, int nMonitoringTimeout)
{
	m_MonMode = nMonitoringMode;
	m_MonTimeout = nMonitoringTimeout;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    GetMonitoringTimeout
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    j^O^CAEgl̎擾
//
//  EXPLANATION
//    j^O^CAEglO擾܂
//
//  RETURN
//    Vj^O^CAEgl
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIcmdsetDlg::GetMonitoringTimeout()
{
	return m_MonTimeout;
}
